* --------------------------------------------------------------------------- *
*                                                       GRAPHIC SEARCHER V2.3 *
*                                          Written by FLASHER JACK OF SCOOPEX *
*swap
*file already exist
*swap spread
* --------------------------------------------------------------------------- *

* ---------------------------------------------------------------- inclusions *
			incdir	"hd12:franck/"
			include	"exec_lib.i"
			include	"graphics_lib.i"
			include	"intuition_lib.i"
			include	"dos_lib.i"

* ---------------------------------------------------------------- constantes *
help_key		equ	$41
enter_key		equ	$77
f1_key			equ	$5f
f2_key			equ	$5d
f3_key			equ	$5b
f4_key			equ	$59
f5_key			equ	$57
f6_key			equ	$55
f7_key			equ	$53
f8_key			equ	$51
f9_key			equ	$4f
flechebs_key		equ	$65
flecheht_key		equ	$67
shiftgauche_key		equ	$3f
shiftdroite_key		equ	$3d
d_key			equ	$bb
pr_cli			equ	172
pr_msgport		equ	92
exg_key			equ	$43
spread_key		equ	$45

* ------------------------------------------------- commandes macro assembler *
activeb			macro
			lea.l	\1,a0
			move.l	_windowbase-debut(a4),a1
			sub.l	a2,a2
			callint	activategadget
			endm
calld			macro
			move.l	_dosbase-debut(a4),a6
			jsr	_LVO\1(a6)
			endm
callg			macro
			move.l	_gfxbase-debut(a4),a6
			jsr	_LVO\1(a6)
			endm
calli			macro
			move.l	_intbase-debut(a4),a6
			jsr	_LVO\1(a6)
			endm

* -------------------------------------------------------- debut du programme *
			section	set_multitache,code

*jump			lea.l	_dosname,a1
*			moveq.l	#0,d0
*			callexe	openlibrary
*			move.l	d0,_dosbase
*			beq.b	erreur_dos_jump
*			jsr	debut
*			move.l	_dosbase,a1
*			callexe	closelibrary
*erreur_dos_jump	rts

* ----------------------------------------------- detache le programme du cli *
set_multitache		movem.l	d1-a6,-(a7)
			sub.l	a1,a1
			callexec findtask
			move.l	d0,a4
			moveq.l	#0,d0
			tst.l	pr_cli(a4)
			bne.b	du_cli
			lea.l	pr_msgport(a4),a0
			callexec waitport
			lea.l	pr_msgport(a4),a0
			callexec getmsg
du_cli			move.l	d0,d7
			lea.l	_dosname,a1
			moveq.l	#0,d0
			callexec openlibrary
			move.l	d0,_dosbase
			beq.b	erreur_dos
			move.l	152(a4),d1
			calldos	duplock
			move.l	d0,_lock_handle
			callexec forbid
			move.l	#procname,d1
			moveq.l	#0,d2
			lea.l	set_multitache-4(pc),a0
			move.l	(a0),d3
			clr.l	(a0)
			move.l	#4000,d4		* stack size
			calldos	createproc
			callexec permit
			move.l	_dosbase,a1
			callexec closelibrary
erreur_dos		tst.l	d7
			beq.b	pas_workbench
			callexec forbid
			move.l	d7,a1
			callexec replymsg
pas_workbench		movem.l	(a7)+,d1-a6
			moveq.l	#0,d0
			rts

			section	main,code

main			movem.l	d1-a6,-(a7)
			bsr.b	debut
			callexec forbid
			move.l	_lock_handle,d1
			calldos unlock
			lea.l	main-4(pc),a0
			move.l	a0,d1
			lsr.l	#2,d1
			calldos	unloadseg
			movem.l	(a7)+,d1-a6
			moveq.l	#0,d0
			rts

* -------------------------------------------------------- debut du programme *
debut			movem.l	d0-a6,-(a7)
			lea.l	debut(pc),a4
			move.l	#$ffdffffe,pal1-debut(a4)
			move.l	#$2b09fffe,pal2-debut(a4)
			move.l	#$2c09fffe,pal3-debut(a4)
			move.l	4.w,a0
			moveq.l	#0,d0
			move.b	530(a0),d0
			cmp.b	#50,d0
			beq.b	pas_ntsc
			move.l	#$1020000,pal1-debut(a4)
			move.l	#$fe09fffe,pal2-debut(a4)
			move.l	#$ff09fffe,pal3-debut(a4)
pas_ntsc
			sf.b	flag_chip1-debut(a4)
			sf.b	flag_chip2-debut(a4)
			lea.l	$c0000,a1		* 1meg
			callexec typeofmem
			tst.l	d0
			beq.b	pas_mask
			move.l	#$fffff,mask-debut(a4)
			st.b	flag_chip1-debut(a4)
pas_mask		lea.l	$140000,a1		* 2meg
			callexec typeofmem
			tst.l	d0
			beq.b	pas_mask2
			st.b	flag_chip2-debut(a4)
			move.l	#$1fffff,mask-debut(a4)
pas_mask2
			lea.l	_gfxname-debut(a4),a1
			moveq.l	#0,d0
			callexec openlibrary
			move.l	d0,_gfxbase-debut(a4)
			beq.w	erreur_gfx

			lea.l	_intname-debut(a4),a1
			moveq.l	#0,d0
			callexec openlibrary
			move.l	d0,_intbase-debut(a4)
			beq.w	erreur_int

			moveq.l	#0,d0			* libere sprite 0
			callg	freesprite

			lea.l	font-debut(a4),a0
			callg	openfont
			move.l	d0,_textfont-debut(a4)

			lea.l	rastport-debut(a4),a1
			callg	initrastport

			move.l	_textfont-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	setfont

			lea.l	bitmap-debut(a4),a0
			move.l	a0,r_bitmap-debut(a4)

			moveq.l	#10,d0
			move.l	#1000,d1
			callg	allocraster
			move.l	d0,_adrcopper-debut(a4)

			moveq.l	#100,d0
			move.l	#240,d1
			callg	allocraster
			move.l	d0,_adrsprite-debut(a4)

			move.l	#800,d0
			moveq.l	#70,d1
			callg	allocraster
			move.l	d0,_adrtext1-debut(a4)

			move.l	#800,d0
			moveq.l	#70,d1
			callg	allocraster
			move.l	d0,_adrtext2-debut(a4)

			lea.l	fenetre(pc),a0
			calli	openwindow
			move.l	d0,_windowbase-debut(a4)
			move.l	d0,a0
			move.l	86(a0),userport-debut(a4)

			lea.l	text_bps+2-debut(a4),a0
			lea.l	_adrtext1-debut(a4),a1
			lea.l	_adrtext2-debut(a4),a2
			move.l	(a1),text_plan1-debut(a4)
			move.w	(a1)+,(a0)
			move.w	(a1),4(a0)
			move.l	(a2),text_plan2-debut(a4)
			move.w	(a2)+,8(a0)
			move.w	(a2),12(a0)

			jsr	place_sprites-debut(a4)

			lea.l	rastport-debut(a4),a1
			moveq.l	#0,d0
			callg	setapen

			lea.l	rastport-debut(a4),a1
			moveq.l	#0,d0
			moveq.l	#0,d1
			move.l	#672,d2
			moveq.l	#60,d3
			callg	rectfill

			moveq.l	#1,d0
			jsr	defpena-debut(a4)

			lea.l	rastport-debut(a4),a1
			move.l	#536,d0
			moveq.l	#4,d1
			move.l	#670,d2
			moveq.l	#60,d3
			callg	rectfill

			lea.l	rastport-debut(a4),a1
			move.l	#430,d0
			moveq.l	#4,d1
			move.l	#530,d2
			moveq.l	#60,d3
			callg	rectfill

			lea.l	rastport-debut(a4),a1
			move.l	#195,d0
			moveq.l	#4,d1
			move.l	#424,d2
			moveq.l	#60,d3
			callg	rectfill

			moveq.l	#0,d0
			jsr	defpena-debut(a4)

			lea.l	rastport-debut(a4),a1
			move.l	#195,d0
			moveq.l	#17,d1
			move.l	#424,d2
			moveq.l	#19,d3
			callg	rectfill

			lea.l	rastport-debut(a4),a1
			move.l	#276,d0
			moveq.l	#19,d1
			move.l	#280,d2
			moveq.l	#60,d3
			callg	rectfill

			moveq.l	#2,d0
			moveq.l	#1,d5
			jsr	defpens-debut(a4)

			lea.l	rastport-debut(a4),a1
			moveq.l	#11,d1
			move.l	#541,d0
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	bps_pointer_mes-debut(a4),a0
			moveq.l	#16,d0
			callg	text

			moveq.l	#3,d0
			moveq.l	#1,d5
			jsr	defpens-debut(a4)

			lea.l	rastport-debut(a4),a1
			move.l	#215,d0
			moveq.l	#13,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	titre_mes-debut(a4),a0
			moveq.l	#24,d0
			callg	text

			moveq.l	#2,d0
			moveq.l	#1,d5
			jsr	defpens-debut(a4)

			moveq.l	#6-1,d5
			moveq.l	#20-1,d4
copy_bps_txt		lea.l	rastport-debut(a4),a1
			move.l	#542,d0
			move.l	d4,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			moveq.l	#16,d0
			lea.l	struct_bp_mes-debut(a4),a0
			callg	text
			addq.l	#8,d4
			dbf	d5,copy_bps_txt

			moveq.l	#6-1,d5
			moveq.l	#20-1,d4
			lea.l	nbr_bps_mes-debut(a4),a5
copy_bps_nbr		lea.l	rastport-debut(a4),a1
			move.l	#542,d0
			move.l	d4,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			moveq.l	#1,d0
			lea.l	(a5),a0
			callg	text
			addq.l	#8,d4
			addq.l	#1,a5
			dbf	d5,copy_bps_nbr

			lea.l	rastport-debut(a4),a1
			move.l	#433-(8*4),d0
			moveq.l	#59,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	iff_mes-debut(a4),a0
			moveq.l	#3,d0
			callg	text

			moveq.l	#11,d5
			lea.l	view_mes-debut(a4),a2
			moveq.l	#7-1,d4
copy_bps_view		lea.l	rastport-debut(a4),a1
			move.l	#433,d0
			move.l	d5,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	(a2),a0
			moveq.l	#12,d0
			callg	text
			lea.l	12(a2),a2
			addq.l	#8,d5
			dbf	d4,copy_bps_view

			moveq.l	#27,d5
			lea.l	viewdim_mes-debut(a4),a2
			moveq.l	#5-1,d4
copy_dim		lea.l	rastport-debut(a4),a1
			move.l	#284,d0
			move.l	d5,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	(a2),a0
			moveq.l	#13,d0
			callg	text
			lea.l	13(a2),a2
			addq.l	#8,d5
			dbf	d4,copy_dim

			lea.l	rastport-debut(a4),a1
			move.l	#197,d0
			moveq.l	#27,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	rgb_mes-debut(a4),a0
			moveq.l	#3,d0
			callg	text

			move.l	_gfxbase-debut(a4),a6
			jsr	lbc001db0-debut(a4)
			jsr	lbc001cf8-debut(a4)
			jsr	lbc0018c4-debut(a4)
			jsr	lbc0015ac-debut(a4)
			jsr	lbc00171c-debut(a4)
			jsr	lbc000d08-debut(a4)
			jsr	lbc0006c2-debut(a4)
			jsr	lbc0012e2-debut(a4)
			jsr	lbc00107c-debut(a4)
			jsr	lbc0010d2-debut(a4)
			jsr	lbc001832-debut(a4)
			jsr	lbc00187c-debut(a4)
			jsr	lbc001b30-debut(a4)
			jsr	lbc000ffa-debut(a4)
			jsr	lbc000fc0-debut(a4)

			move.l	4.w,a6
			jsr	-132(a6)

lbc00053c		move.l	_gfxbase-debut(a4),a6
			jsr	lbc0011ea-debut(a4)
			tst.l	lbl002438-debut(a4)
			bne.w	lbc000e44
			move.l	lbl002434-debut(a4),lbl002438-debut(a4)
			jsr	lbc001abe-debut(a4)
			tst.b	lbb0024c8-debut(a4)
			beq.b	lbc000604
			jmp	lbc000e4a-debut(a4)
lbc000604		moveq.l	#0,d0
			moveq.l	#0,d1
			lea.l	lbb000572-debut(a4),a0
lbc00060e		tst.b	flag_echange3-debut(a4)	* bloque pour le
			beq.b	pas_bloque_swap		* swap mode
			move.b	#exg_key,d1
			moveq.l	#41,d0
			cmp.b	#exg_key,$bfec01	* sm
			beq.b	lbc000624
			move.b	#$79,d1
			moveq.l	#18,d0
			cmp.b	#$79,$bfec01		* +
			beq.b	lbc000624
			move.b	#$6b,d1
			moveq.l	#19,d0
			cmp.b	#$6b,$bfec01		* -
			beq.b	lbc000624
			jmp	lbc000604-debut(a4)
pas_bloque_swap
			tst.b	flag_spread3-debut(a4)	* bloque pour le
			beq.b	pas_bloque_spread	* spread mode
			move.b	#spread_key,d1
			moveq.l	#42,d0
			cmp.b	#spread_key,$bfec01	* sm
			beq.b	lbc000624
			move.b	#$79,d1
			moveq.l	#18,d0
			cmp.b	#$79,$bfec01		* +
			beq.b	lbc000624
			move.b	#$6b,d1
			moveq.l	#19,d0
			cmp.b	#$6b,$bfec01		* -
			beq.b	lbc000624
			jmp	lbc000604-debut(a4)
pas_bloque_spread
			move.b	(a0)+,d1
			cmp.b	$bfec01,d1
			beq.b	lbc000624
			addq.b	#1,d0
			cmp.b	lbb00058f-debut(a4),d0
			bne.w	lbc00060e
			beq.b	lbc000632
lbc000624		add.l	d0,d0
			add.l	d0,d0
			lea.l	lbl000590-debut(a4),a0
			move.l	(a0,d0.w),a0
			jsr	(a0)

lbc000632		jsr	lbc0013bc-debut(a4)
			cmp.b	#$af,$bfec01		* lo
			beq.w	lbc000bcc
			cmp.b	#$b5,$bfec01		* hi
			beq.w	lbc000c3a
			jmp	lbc000cc0-debut(a4)
lbc000652		sf.b	$bfec01			* change tout les bps
			move.l	#6-1,d0
			lea.l	lbl002468-debut(a4),a0
lbc00065e		not.b	(a0)+
			dbf	d0,lbc00065e
			jmp	lbc00107c-debut(a4)
lbc00066a		add.l	#256,lbl002434-debut(a4)
			cmp.l	#9728,lbl002434-debut(a4)
			ble.b	lbc00068a
			move.l	#1024,lbl002434-debut(a4)
lbc00068a		lea.l	lbl002434-debut(a4),a0
			jsr	lbc001132-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#$1f1,d0
			moveq.l	#$33,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	lbb001176-debut(a4),a0
			moveq.l	#4,d0
			callg	text
			rts
lbc0006c2		sub.l	#256,lbl002434-debut(a4)
			cmp.l	#1024,lbl002434-debut(a4)
			bhi.b	lbc00068a
			move.l	#$2500,lbl002434-debut(a4)
			jmp	lbc00068a-debut(a4)
lbc0006e4		sf.b	$bfec01
			lea.l	rastport-debut(a4),a1
			move.l	#201,d0
			moveq.l	#43,d1
			callg	move
			moveq.l	#9,d0
			lea.l	vide_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			rts

* ------------------------------------------------------- definis les sprites *
place_sprites		move.l	_adrsprite-debut(a4),a0
			moveq.l	#4-1,d4
copy_sprite_bps		moveq.l	#60-1,d1
copy_sprite_bp1		move.l	#-1,(a0)+
			dbf	d1,copy_sprite_bp1
			moveq.l	#60-1,d1
copy_sprite_bp2		move.l	#$ffff,(a0)+
			dbf	d1,copy_sprite_bp2
			dbf	d4,copy_sprite_bps
			move.l	_adrsprite-debut(a4),_spritelohi-debut(a4)
			lea.l	sprites_bps+2-debut(a4),a0
			moveq.l	#8-1,d2
copy_plans_sprite	move.w	_spritelohi-debut(a4),(a0)
			move.w	_spritelohi+2-debut(a4),4(a0)
			addq.l	#8,a0
			add.l	#240,_spritelohi-debut(a4)
			dbf	d2,copy_plans_sprite
			move.l	_adrsprite-debut(a4),a0
			moveq.l	#36,d0
			moveq.l	#57,d1
			moveq.l	#8-1,d2
copy_pos_sprite		move.b	d0,(a0)
			move.b	d1,1(a0)
			move.w	#$5e01,2(a0)
			lea.l	240(a0),a0
			addq.l	#6,d1
			dbf	d2,copy_pos_sprite
			rts

lbc000760		jsr	lbc0007ac-debut(a4)

* --------------------------------------------------------- mode de recherche *
lbc000762		cmp.b	#$77,$bfec01		* termine
			beq.w	lbc0006e4
			cmp.b	#$fd,$bfec01		* mode 1 ok/no
			bne.b	lbc000782
			bchg.b	#2,lbb00071f-debut(a4)
			sf.b	$bfec01
			jsr	lbc0007ac-debut(a4)
lbc000782		cmp.b	#$fb,$bfec01		* mode 2 ok/no
			bne.b	lbc000796
			sf.b	$bfec01
			bchg.b	#1,lbb00071f-debut(a4)
			jsr	lbc0007ac-debut(a4)
lbc000796		cmp.b	#$f9,$bfec01		* mode 3 ok/no
			bne.b	lbc0007aa
			sf.b	$bfec01
			bchg.b	#0,lbb00071f-debut(a4)
			jsr	lbc0007ac-debut(a4)
lbc0007aa		jmp	lbc000762-debut(a4)

lbc0007ac		movem.l	d0-a6,-(a7)
			lea.l	rastport-debut(a4),a1
			move.l	#201,d0
			moveq.l	#43,d1
			callg	move
			moveq.l	#6,d0
			lea.l	mode_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			moveq.l	#0,d6
			moveq.l	#2,d7
lbc0007e0		move.b	lbb00071f,d5
			lsr.l	d7,d5
			and.l	#1,d5
			lea.l	rastport-debut(a4),a1
			move.l	#249,d0
			moveq.l	#43,d1
			add.l	d6,d0
			movem.l	d5-d7,-(a7)
			callg	move
			movem.l	(a7)+,d5-d7
			addq.w	#8,d6
			moveq.l	#1,d0
			lea.l	mode_onoff_mes-debut(a4),a0
			add.l	d5,a0
			lea.l	rastport-debut(a4),a1
			movem.l	d5-d7,-(a7)
			callg	text
			movem.l	(a7)+,d5-d7
			dbf	d7,lbc0007e0
			movem.l	(a7)+,d0-a6
			rts

lbc00083e		movem.l	d0-a6,-(a7)
			subq.l	#2,lbl000716-debut(a4)
			lea.l	lbl000716-debut(a4),a0
			movem.l	d0-a6,-(a7)
			jsr	lbc001132-debut(a4)
			movem.l	(a7)+,d0-a6
			addq.l	#2,lbl000716-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#197,d0
			moveq.l	#35,d1
			callg	move
			moveq.l	#4,d0
			lea.l	adr_col_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			lea.l	rastport-debut(a4),a1
			move.l	#233,d0
			moveq.l	#35,d1
			callg	move
			moveq.l	#5,d0
			lea.l	lbb001175-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			movem.l	(a7)+,d0-a6
			rts

* --------------------------------------------------- cherche une copperliste *
lbc0008c0		move.l	lbl000716-debut(a4),old-debut(a4)
			addq.l	#2,lbl000716-debut(a4)
			movem.l	d0-a6,-(a7)
			moveq.l	#3,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199,d0
			moveq.l	#43,d1
			callg	move
			moveq.l	#9,d0
			lea.l	search_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)

lbc0008f6		move.l	lbl000716-debut(a4),lbl000712-debut(a4)
			move.l	lbl000712-debut(a4),a0
			cmp.w	#$180,(a0)
			bne.b	lbc00094e
			move.w	2(a0),d0
			and.w	#$f000,d0
			bne.b	lbc00094e		* check couleur
			cmp.w	#$182,4(a0)
			bne.b	lbc00094e
			move.w	6(a0),d0
			and.w	#$f000,d0
			bne.b	lbc00094e
			move.l	lbl000712-debut(a4),lbl000716-debut(a4)
			lea	lbl000720-debut(a4),a1
			moveq.l	#32-1,d0
lbc000938		move.w	2(a0),(a1)+
			lea	4(a0),a0
			dbf	d0,lbc000938
			addq.l	#2,lbl000716-debut(a4)
			jmp	lbc000ade-debut(a4)
lbc00094e		addq.l	#2,lbl000716-debut(a4)
			move.l	mask-debut(a4),d0
			move.l	lbl000716-debut(a4),d1
			cmp.l	d0,d1
			bhi	lbc000b58
			move.w	a0,$dff184
			cmp.b	#$75,$bfec01
			beq	break_com
			jmp	lbc0008f6-debut(a4)

* --------------------------------------------- cherche une table de couleurs *
lbc00097e		move.l	lbl000716-debut(a4),old-debut(a4)
			addq.l	#2,lbl000716-debut(a4)
			movem.l	d0-a6,-(a7)
			moveq.l	#3,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199,d0
			moveq.l	#43,d1
			callg	move
			moveq.l	#9,d0
			lea.l	search_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)

lbc0009b8		move.l	lbl000716-debut(a4),lbl000712-debut(a4)
			move.l	lbl000712-debut(a4),a0
			lea.l	lbl000720-debut(a4),a3
			moveq.l	#2,d4

lbc0009d4		move.l	lbl000712-debut(a4),a0
			move.w	(a0),d0
			and.w	#$f000,d0
			bne	lbc000b2c
			move.w	(a0),(a3,d4.w)
			addq.l	#2,d4			* prochaine col
			addq.l	#2,lbl000712-debut(a4)
			move.l	mask-debut(a4),d0
			move.l	lbl000712-debut(a4),d1
			cmp.l	d0,d1
			bhi.w	lbc000b58
			moveq.l #0,d6
			move.b	lbb002472-debut(a4),d6
			cmp.b	#"6",d6			* 32 couleurs au max
			bne.b	pas_half
			move.b	#"5",d6
			cmp.b	#1,flag_ham-debut(a4)
			bne.b	pas_half
			move.b	#"4",d6
pas_half		sub.b	#"0",d6			* max couleurs
			moveq.l	#1,d7
			lsl.l	d6,d7
			add.l	d7,d7
			cmp.l	d7,d4
			bne.b	lbc0009d4

			subq.w	#3,d7
			not.w	d7
			move.w	d7,lbl000a2a+2-debut(a4)

lbl000a2a		move.w	-62(a0),(a3)		* (32*2)
			move.w	(a3),d0			* 0 ???
			beq.b	lbc000a3c
			and.w	#$f000,d0		* une couleur ???
			bne.w	lbc000b2c		* non.
lbc000a3c
			btst.b	#0,lbb00071f-debut(a4)		* mode 1
			beq.b	lbc000a70
			lea.l	lbl000720-debut(a4),a0		* table cols
			move.w	#$180,d0			* col1 copper
lbc000a50		cmp.w	(a0),d0
			bne.b	lbc000a70
			addq.l	#4,a0
			add.l	#126,lbl000716-debut(a4)
			jmp	lbc000b2c-debut(a4)
lbc000a70
			btst.b	#1,lbb00071f-debut(a4)		* mode 2
			beq.w	lbc000aa4		* 1 couleur (normal)
			moveq.l	#0,d1
			lea.l	lbl000720-debut(a4),a0
			move.b	(a0),d1
			moveq.l	#16-1,d0
check2			cmp.b	(a0),d1
			bne.b	lbc000aa4
			addq.l	#2,a0
			cmp.b	(a0),d1
			bne.b	lbc000aa4
			addq.l	#2,a0
			dbf	d0,check2

			add.l	#62,lbl000716-debut(a4)		* (*2)
			jmp	lbc000b2c-debut(a4)
lbc000aa4
			btst.b	#2,lbb00071f-debut(a4)		* mode 3
			beq	lbc000ade		* (au moins 3 couleurs)
			lea.l	lbl000720-debut(a4),a0
			moveq.l	#32-1,d0
			moveq.l #0,d2
			moveq.l #0,d3
lbc000abc		move.w	(a0)+,d2
			moveq.l #0,d3
			moveq	#32-1,d1
			lea.l	lbl000720-debut(a4),a1
lbc000ac8		cmp.w	(a1)+,d2
			bne.b	lbc000ad6
			addq.w	#1,d3
			cmp.w	#3,d3
			beq.w	lbc000b2c
lbc000ad6		dbf	d1,lbc000ac8
			dbf	d0,lbc000abc

lbc000ade		jsr	lbc00083e-debut(a4)
			lea.l	lbl000720-debut(a4),a0
			lea.l	lbl002274-debut(a4),a1
			rept	31
			move.w	(a0)+,(a1)+
			endr
			move.w	(a0),(a1)

			moveq.l	#3,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199,d0
			moveq.l	#43,d1
			callg	move
			moveq.l	#9,d0
			lea.l	trouve_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			jsr	lbc001db0-debut(a4)
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			movem.l	(a7)+,d0-a6
			rts

lbc000b2c		addq.l	#2,lbl000716-debut(a4)
			move.l	mask-debut(a4),d0
			move.l	lbl000716-debut(a4),d1
			cmp.l	d0,d1
			bhi.b	lbc000b58
			move.w	a0,$dff184
			cmp.b	#$75,$bfec01
			beq.b	break_com
			jmp	lbc0009b8-debut(a4)

* -------------------------------------------------------------------- arret! *
break_com		subq.l	#2,old-debut(a4)
			move.l	old-debut(a4),lbl000716-debut(a4)
			moveq.l	#3,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199,d0
			moveq.l	#43,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	break_mes-debut(a4),a0
			moveq.l	#9,d0
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			movem.l	(sp)+,d0-a6
			rts

* ------------------------------------------------------------ pas de palette *
lbc000b58		move.l	_bitplanepointeur-debut(a4),lbl000716-debut(a4)
			moveq.l	#3,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199,d0
			moveq.l	#43,d1
			callg	move
			moveq.l	#9,d0
			lea.l	rien_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			movem.l	(a7)+,d0-a6
			rts

lbc000b94		subq.l	#2,lbl000716-debut(a4)
			jmp	lbc000ba2-debut(a4)
lbc000b9c		addq.l	#2,lbl000716-debut(a4)
lbc000ba2		movem.l	d0-a6,-(sp)
			move.l	lbl000716-debut(a4),d0
			and.l	mask-debut(a4),d0
			move.l	d0,a0
			lea.l	lbl002274-debut(a4),a1
			moveq	#$1f,d0
lbc000bbc		move.w	(a0)+,(a1)+
			dbf	d0,lbc000bbc
			jsr	lbc001db0-debut(a4)
			movem.l	(sp)+,d0-a6
			rts

* ---------------------------------------------------------------- mode lores *
lbc000bcc		sf.b	$bfec01
			sf.b	flag_hi-debut(a4)
			bclr.b	#15,bp_pointeur-debut(a4)
			move.l	#$28,lbl002474-debut(a4)
			move.l	#$38,lbw002494-debut(a4)
			move.l	#$d0,lbb002498-debut(a4)
			jsr	lbc001576-debut(a4)
			jsr	lbc00164a-debut(a4)
			jsr	lbc00171c-debut(a4)
			jsr	lbc001832-debut(a4)
			jsr	lbc00187c-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#$1e9,d0
			moveq.l	#11,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	lo_mes-debut(a4),a0
			moveq.l	#2,d0
			callg	text
			jsr	lbc000ffa-debut(a4)
			jmp	lbc000cc0-debut(a4)

* ---------------------------------------------------------------- mode hires *
lbc000c3a		sf.b	$bfec01
			jsr	ham-debut(a4)
			st.b	flag_hi-debut(a4)
			bset.b	#15,bp_pointeur-debut(a4)
			move.l	#$50,lbl002474-debut(a4)
			move.l	#$3c,lbw002494-debut(a4)
			move.l	#$d4,lbb002498-debut(a4)
			jsr	lbc001576-debut(a4)
			jsr	lbc00171c-debut(a4)
			jsr	lbc00164a-debut(a4)
			jsr	lbc001832-debut(a4)
			jsr	lbc00187c-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#$1e9,d0
			moveq.l	#11,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	hi_mes-debut(a4),a0
			moveq.l	#2,d0
			callg	text
			jsr	lbc000ffa-debut(a4)
			cmp.b	#"6",lbb002472-debut(a4)
			beq.b	pas_6
			cmp.b	#"5",lbb002472-debut(a4)
			beq.b	pas_5
			jmp	lbc000cc0-debut(a4)
pas_6			subq.b	#2,lbb002472-debut(a4)
			jmp	cont-debut(a4)
pas_5			subq.b	#1,lbb002472-debut(a4)
cont			jsr	lbc000ffa-debut(a4)
			jsr	lbc000d4c-debut(a4)
			jmp	lbc000e1c-debut(a4)

lbc000cc0		cmp.b	#$e7,$bfec01		* ajoute un plan
			beq.b	lbc000cd8
			cmp.b	#$e9,$bfec01		* supprime un plan
			beq.b	lbc000cf0
			jmp	lbc000e1c-debut(a4)

lbc000cd8		move.l	#1,lbl0024c4-debut(a4)
			jsr	lbc001cf8-debut(a4)
			sf.b	$bfec01
			move.b	lbb002472-debut(a4),d0
			cmp.b	lbb002473-debut(a4),d0
			bcc	lbc000e1c
			addq.b	#1,lbb002472-debut(a4)
			jmp	lbc000d02-debut(a4)
lbc000cf0
			move.l	#1,lbl0024c4-debut(a4)
			jsr	lbc001cf8-debut(a4)
			sf.b	$bfec01
			cmp.b	#"2",lbb002472-debut(a4)
			bcs	lbc000e1c
			subq.b	#1,lbb002472-debut(a4)
lbc000d02		jsr	lbc000d08-debut(a4)
			jmp	lbc000e1c-debut(a4)

lbc000d08		cmp.b	#"0",lbb002472-debut(a4)	* 0 plans
			bne.b	lbc000d2a
			moveq.l	#0,d0
			moveq.l	#6,d1
			move.w	#$8fff,d2
			clr.w	d3
			jsr	lbc00101c-debut(a4)
lbc000d2a
			cmp.b	#"1",lbb002472-debut(a4)	* 1 plan
			bne.b	lbc000d4c
			moveq.l	#1,d0
			moveq.l	#5,d1
			move.w	#$8fff,d2
			move.w	#$1000,d3
			jsr	lbc00101c-debut(a4)
lbc000d4c
			cmp.b	#"2",lbb002472-debut(a4)	* 2 plans
			bne.b	lbc000d6e
			moveq.l	#2,d0
			moveq.l	#4,d1
			move.w	#$8fff,d2
			move.w	#$2000,d3
			jsr	lbc00101c-debut(a4)
lbc000d6e
			cmp.b	#"3",lbb002472-debut(a4)	* 3 plans
			bne.b	lbc000d90
			moveq.l	#3,d0
			moveq.l	#3,d1
			move.w	#$8fff,d2
			move.w	#$3000,d3
			jsr	lbc00101c-debut(a4)
lbc000d90
			cmp.b	#"4",lbb002472-debut(a4)	* 4 plans
			bne.b	lbc000db2
			moveq.l	#4,d0
			moveq.l	#2,d1
			move.w	#$8fff,d2
			move.w	#$4000,d3
			jsr	lbc00101c-debut(a4)
lbc000db2
			cmp.b	#"5",lbb002472-debut(a4)	* 4 plans
			bne.b	lbc000db2b
			btst.b	#15,bp_pointeur-debut(a4)	* hires
			bne.b	lbc000de0
			moveq.l	#5,d0
			moveq.l	#1,d1
			move.w	#$8fff,d2
			move.w	#$5000,d3
			jsr	lbc00101c-debut(a4)
lbc000db2b
			cmp.b	#"6",lbb002472-debut(a4)	* 6 plans
			bne.b	lbc000de6
			btst.b	#15,bp_pointeur-debut(a4)	* hires
			bne.b	lbc000de0
			moveq.l	#6,d0
			moveq.l	#0,d1
			move.w	#$8fff,d2
			move.w	#$6000,d3
			jsr	lbc00101c-debut(a4)
			jmp	lbc000de6-debut(a4)

lbc000deb		subq.b	#1,lbb002472-debut(a4)
lbc000de0		subq.b	#1,lbb002472-debut(a4)
lbc000de6		jsr	lbc000ffa-debut(a4)
			jsr	lbc0010d2-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#$209,d0
			moveq.l	#$13,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			moveq.l	#1,d0
			lea.l	lbb002472-debut(a4),a0
			callg	text
			rts

lbc000e1c		move.l	#$f3,d0
			moveq.l	#6-1,d1
			lea.l	lbb00246c-1-debut(a4),a0
lbc000e2e		cmp.b	$bfec01,d0
			bne.b	lbc000e38
			sf.b	$bfec01
			not.b	(a0)
lbc000e38		addq.l	#2,d0
			subq.l	#1,a0
			dbf	d1,lbc000e2e
			jsr	lbc00107c-debut(a4)
lbc000e44		subq.l	#1,lbl002438-debut(a4)

lbc000e4a		cmp.b	#$4d,$bfec01
			bne	lbc00053c

			move.l	4.w,a6
			jsr	-138(a6)

			jsr	lbc000fe0-debut(a4)

			move.l	_adrcopper-debut(a4),a0
			moveq.l	#10,d0
			move.l	#1000,d1
			callg	freeraster

			move.l	_adrsprite-debut(a4),a0
			moveq.l	#100,d0
			move.l	#240,d1
			callg	freeraster

			move.l	_adrtext1-debut(a4),a0
			move.l	#800,d0
			moveq.l	#70,d1
			callg	freeraster

			move.l	_adrtext2-debut(a4),a0
			move.l	#800,d0
			moveq.l	#70,d1
			callg	freeraster

			move.l	_intbase-debut(a4),a6
			move.l	_windowbase-debut(a4),a0
			calli	closewindow

			move.l	_textfont-debut(a4),a1
			callg	closefont
			move.l	_intbase-debut(a4),a1
			callexec closelibrary
erreur_int		move.l	_gfxbase-debut(a4),a1
			callexec closelibrary
erreur_gfx		movem.l	(a7)+,d0-a6
			rts

lbc000eee		jsr	lbc000fe0-debut(a4)
			clr.l	lbl002188-debut(a4)
			jsr	lbc000f5c-debut(a4)
lbc000f08		jsr	lbc000f8c-debut(a4)
			move.l	d0,a0
			move.l	20(a0),d0
			cmp.w	#$40,d0
			beq.b	lbc000f1e
			jsr	lbc000fae-debut(a4)
			jmp	lbc000f08-debut(a4)
lbc000f1e		move.l	$1c(a0),d0
			cmp.l	#lbl0020f2,d0
			beq.b	lbc000f4a
			cmp.l	#lbl002188,d0
			beq.b	lbc000f34
			activeb	gadget
			jmp	lbc000f08-debut(a4)
lbc000f34		jsr	lbc000fae-debut(a4)
			jsr	lbc000f74-debut(a4)
			jsr	lbc00192a-debut(a4)
			jsr	lbc000fc0-debut(a4)
			move.l	_gfxbase-debut(a4),a6
			rts
lbc000f4a		jsr	lbc000fae-debut(a4)
			jsr	lbc000f74-debut(a4)
			jsr	lbc000fc0-debut(a4)
			move.l	_gfxbase-debut(a4),a6
			rts

lbc000f5c		lea	lbl001f56-debut(a4),a0
			move.l	_intbase-debut(a4),a6
			move.l	_windowbase-debut(a4),a1
			jmp	-240(a6)

lbc000f74		move.l	_intbase-debut(a4),a6
			move.l	_windowbase-debut(a4),a1
			lea	lbl001f56-debut(a4),a0
			jmp	-120(a6)

lbc000f8c		move.l	4.w,a6
			move.l	userport-debut(a4),a0
			jsr	-384(a6)
			move.l	userport-debut(a4),a0
			jsr	-372(a6)
			move.l	d0,lbl002354-debut(a4)
			rts

lbc000fae		move.l	4.w,a6
			move.l	lbl002354-debut(a4),a1
			jmp	-378(a6)

lbc000fc0		move.l	_gfxbase-debut(a4),a6
			lea.l	50(a6),a6
			move.l	(a6),old_copper-debut(a4)
			move.l	_adrcopper-debut(a4),(a6)
			move.l	_gfxbase-debut(a4),a6
			rts

lbc000fe0		move.l	_gfxbase-debut(a4),a6
			lea.l	50(a6),a6
			move.l	old_copper-debut(a4),(a6)
			move.l	_gfxbase-debut(a4),a6
			rts

lbc000ffa		movem.l	d0/a0/a1,-(a7)
			move.l	_adrcopper-debut(a4),a0
			lea.l	copper-debut(a4),a1
			move.l	#(fincopper-copper)-1,d0
lbc001010		move.b	(a1)+,(a0)+
			dbf	d0,lbc001010
			movem.l	(a7)+,d0/a0/a1
			rts

lbc00101c		and.w	d2,bp_pointeur-debut(a4)
			or.w	d3,bp_pointeur-debut(a4)
			lea.l	ascii.msg-debut(a4),a0
			moveq.l	#0,d2
			tst.l	d0
			beq.b	lbc001046
lbc00103c		move.b	#1,(a0)+
			addq.l	#1,d2
			cmp.l	d0,d2
			bne.b	lbc00103c
lbc001046
			moveq.l	#0,d2
			tst.l	d1
			beq.b	lbc001060
lbc001054		sf.b	(a0)+
			addq.l	#1,d2
			cmp.l	d1,d2
			bne.b	lbc001054
			jmp	lbc000ffa-debut(a4)
lbc001060		rts

defpena			lea.l	rastport-debut(a4),a1
			callg	setapen
			rts

defpenb			move.l	d5,d0
			lea.l	rastport-debut(a4),a1
			callg	setbpen
			rts

lbc00107c		moveq.l	#6-1,d5
			moveq.l	#19,d4
			lea.l	lbl002468-debut(a4),a3
lbc00108e		lea.l	rastport-debut(a4),a1
			move.l	#$24d,d0
			move.l	d4,d1
			callg	move
			tst.b	(a3)
			beq.b	lbc0010ae
			lea.l	bp_ok_mes-debut(a4),a0
			jmp	lbc0010b4-debut(a4)
lbc0010ae		lea.l	bp_no_mes-debut(a4),a0
lbc0010b4		lea.l	rastport-debut(a4),a1
			moveq.l	#2,d0
			callg	text
			addq.l	#8,d4
			addq.l	#1,a3
			dbf	d5,lbc00108e
			rts

lbc0010d2		moveq.l	#6-1,d5
			moveq.l	#19,d4
			lea.l	ascii.msg-debut(a4),a3
lbc0010e4		lea.l	rastport-debut(a4),a1
			move.l	#$22d,d0
			move.l	d4,d1
			callg	move
			tst.b	(a3)
			beq.b	lbc001104
			lea.l	bp_on_mes-debut(a4),a0
			jmp	lbc00110a-debut(a4)
lbc001104		lea.l	bp_off_mes-debut(a4),a0
lbc00110a		lea.l	rastport-debut(a4),a1
			moveq.l	#3,d0
			callg	text
			addq.l	#8,d4
			addq.l	#1,a3
			dbf	d5,lbc0010e4
			rts

defpens			jsr	defpena-debut(a4)
			jmp	defpenb-debut(a4)

lbc001132		moveq.l	#4,d1
			lea.l	abcdef.msg-debut(a4),a2
			lea.l	lbw001172-debut(a4),a1
			moveq.l #0,d0
lbc001146		move.b	(a0),d0
			and.b	#$f0,d0
			lsr.b	#4,d0
			move.b	0(a2,d0.l),(a1)+
			move.b	(a0)+,d0
			and.b	#15,d0
			move.b	0(a2,d0.l),(a1)+
			dbf	d1,lbc001146
			rts

abcdef.msg		dc.b	"0123456789abcdef"
lbw001172		dc.w	0
lbb001174		dc.b	0
lbb001175		dc.b	0
lbb001176		dc.b	0
lbb001177		dc.b	0,0,0,0,0
			moveq.l	#$13,d3
			moveq.l	#5-1,d4
lbc001188		lea.l	rastport-debut(a4),a1
			move.l	#$266,d0
			move.l	d3,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			moveq.l	#1,d0
			lea.l	(a2),a0
			callg	text
			addq.l	#8,d3
			dbf	d4,lbc001188
			moveq.l	#$1b,d3
			moveq.l	#3-1,d4
lbc0011be		lea.l	rastport-debut(a4),a1
			move.l	#$1f1,d0
			move.l	d3,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			moveq.l	#1,d0
			lea.l	(a2),a0
			callg	text
			addq.l	#8,d3
			dbf	d4,lbc0011be
			rts
lbc0011ea		subq.l	#1,lbl00243c-debut(a4)
			beq.b	lbc0011f4
			rts
lbc0011f4		move.l	#100,lbl00243c-debut(a4)
			cmp.b	#flechebs_key,$bfec01		* bas
			beq.b	lbc001258
			cmp.b	#flecheht_key,$bfec01		* haut
			beq.b	lbc00122c
			cmp.b	#$61,$bfec01			* gauche
			beq	lbc001294
			cmp.b	#$63,$bfec01			* droite
			beq	lbc0012bc
			rts

lbc00122c		moveq.l	#1,d4
			cmp.b	#$ff,lbb0024c8-debut(a4)
			bne.b	lbc001240
			jsr	lbc001bfe-debut(a4)
lbc001240		move.l	lbl002474-debut(a4),d0
			sf.b	d2
			jsr	lbc0012fe-debut(a4)
			jsr	lbc001346-debut(a4)
			jsr	lbc000ffa-debut(a4)
lbc001256		rts

lbc001258		cmp.b	#$ff,lbb0024c8-debut(a4)
			bne.b	lbc00127e
			jsr	lbc001be4-debut(a4)
			move.l	lbl002474-debut(a4),d0
			sf.b	d2
			jsr	lbc0012fe-debut(a4)
			jsr	lbc001346-debut(a4)
			jmp	lbc000ffa-debut(a4)

lbc00127e		move.l	lbl002474-debut(a4),d0
			move.b	#1,d2
			jsr	lbc0012fe-debut(a4)
			jsr	lbc001346-debut(a4)
			jmp	lbc000ffa-debut(a4)

lbc001294		tst.b	lbb0024c8-debut(a4)
			bne	lbc001060
			move.l	#$384,d4
			moveq.l	#2,d0
			sf.b	d2
			jsr	lbc0012fe-debut(a4)
			jsr	lbc001346-debut(a4)
			jmp	lbc000ffa-debut(a4)

lbc0012bc		tst.b	lbb0024c8-debut(a4)
			bne.w	lbc001060
			move.l	#$384,d4
			moveq.l	#2,d0
			move.b	#1,d2
			jsr	lbc0012fe-debut(a4)
			jsr	lbc001346-debut(a4)
			jmp	lbc000ffa-debut(a4)

lbc0012e2		moveq.l	#(6*2)-1,d0			* copy les bps
			lea.l	compteur_bp1-debut(a4),a0	* ds la copper
			lea.l	lbw002742-debut(a4),a2
lbc0012f4		move.w	(a0)+,(a2)
			addq.l	#4,a2
			dbf	d0,lbc0012f4
			rts

lbc0012fe		move.l	d4,lbl00243c-debut(a4)
			cmp.b	#"0",lbb002472-debut(a4)	* pas de plans
			beq.w	lbc001256
			moveq.l #0,d1
			move.b	lbb002472-debut(a4),d1
			sub.l	#"1",d1
			lea.l	lbl002468-debut(a4),a0
			lea.l	compteur_bp1-debut(a4),a1
lbc00132a		cmp.b	#-1,(a0)+
			bne.b	lbc00133c
			cmp.b	#1,d2
			beq.b	lbc00133a
			add.l	d0,(a1)
			jmp	lbc00133c-debut(a4)
lbc00133a		sub.l	d0,(a1)
lbc00133c		addq.l	#4,a1
			dbf	d1,lbc00132a
			jmp	lbc0012e2-debut(a4)

lbc001346		move.l	mask-debut(a4),d0
			and.l	d0,compteur_bp1-debut(a4)
			and.l	d0,compteur_bp2-debut(a4)
			and.l	d0,compteur_bp3-debut(a4)
			and.l	d0,compteur_bp4-debut(a4)
			and.l	d0,compteur_bp5-debut(a4)
			and.l	d0,compteur_bp6-debut(a4)
			lea.l	compteur_bp1-debut(a4),a5
			moveq.l	#$13,d2
			moveq.l	#6-1,d3
lbc00137c		lea.l	(a5),a0
			movem.l	d0-a6,-(a7)
			jsr	lbc001132-debut(a4)
			movem.l	(a7)+,d0-a6
			lea.l	rastport-debut(a4),a1
			move.l	#$26e,d0
			move.l	d2,d1
			callg	move
			moveq.l	#6,d0
			lea.l	lbb001174-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			addq.l	#4,a5
			addq.l	#8,d2
			dbf	d3,lbc00137c
			rts

lbc0013bc		cmp.b	#"0",lbb002472-debut(a4)
			beq	lbc001060
			cmp.b	#$31,$bfec01			* amiga droite
			beq.b	lbc0013de
			cmp.b	#$35,$bfec01			* alt droite
			beq.b	lbc00143c
			rts

lbc0013de		move.l	lbl0024a4-debut(a4),d0
			divu.w	#8,d0
			move.l	lbb0024a8-debut(a4),d1
			mulu.w	d0,d1
			move.l	d1,lbl002478-debut(a4)
			move.l	lbl002434-debut(a4),lbl002438-debut(a4)
			lea.l	compteur_bp1-debut(a4),a0
			lea.l	lbl002468-debut(a4),a1
			moveq.l	#0,d0
			move.b	lbb002472-debut(a4),d0
			sub.l	#"1",d0
			move.l	lbl002478-debut(a4),d1
lbc00141e		cmp.b	#-1,(a1)
			bne.b	lbc001426
			sub.l	d1,(a0)
lbc001426		addq.l	#1,a1
			addq.l	#4,a0
			dbf	d0,lbc00141e

			jsr	lbc001346-debut(a4)
			jsr	lbc0012e2-debut(a4)
			jmp	lbc000ffa-debut(a4)
lbc00143c		move.l	lbl0024a4-debut(a4),d0
			divu.w	#8,d0
			move.l	lbb0024a8-debut(a4),d1
			mulu.w	d0,d1
			move.l	d1,lbl002478-debut(a4)
			move.l	lbl002434-debut(a4),lbl002438-debut(a4)
			lea	compteur_bp1-debut(a4),a0
			lea	lbl002468-debut(a4),a1
			moveq.l	#0,d0
			move.b	lbb002472-debut(a4),d0
			sub.l	#"1",d0
			move.l	lbl002478-debut(a4),d1
lbc00147c		cmp.b	#-1,(a1)
			bne.b	lbc001484
			add.l	d1,(a0)
lbc001484		addq.l	#1,a1
			addq.l	#4,a0
			dbf	d0,lbc00147c
			jsr	lbc001346-debut(a4)
			jsr	lbc0012e2-debut(a4)
			jmp	lbc000ffa-debut(a4)

lbc00149a		cmp.b	#"2",lbb002472-debut(a4)
			bcs.w	lbc001060
			move.l	lbl002434-debut(a4),lbl002438-debut(a4)
			lea.l	compteur_bp1-debut(a4),a0
			lea.l	compteur_bp2-debut(a4),a1
			move.l	lbl0024a4-debut(a4),d0
			divu.w	#8,d0
			move.l	lbb0024a8-debut(a4),d1
			mulu.w	d0,d1
			move.l	d1,lbl002478-debut(a4)
			moveq.l	#0,d0
			move.b	lbb002472-debut(a4),d0
			sub.l	#"2",d0
			move.l	lbl002478-debut(a4),d1
			move.l	(a0),d2
lbc0014e8		add.l	d1,d2
			move.l	d2,(a1)
			addq.l	#4,a1
			dbf	d0,lbc0014e8
			jsr	lbc001346-debut(a4)
			jsr	lbc0012e2-debut(a4)
			jmp	lbc000ffa-debut(a4)

lbc001500		movem.l	d0-a6,-(sp)
			move.l	(a0),a0
			move.l	a0,d0
			move.l	#$2710,d2
			moveq.l	#0,d3
lbc00152c		cmp.l	d2,a0
			bcs.b	lbc001540
			divu.w	d2,d0
			move.b	d0,d1
			add.b	#"0",d1
			move.b	d1,0(a1,d3.l)
			lsr.w	#8,d0
			swap.w	d0
lbc001540		divu.w	#10,d2
			addq.l	#1,d3
			cmp.l	#5,d3
			bne.b	lbc00152c
			movem.l	(sp)+,d0-d7/a0-a6
			rts

lbc001554		addq.l	#2,lbb00249c-debut(a4)
			jmp	lbc0015ac-debut(a4)
lbc00155e		tst.l	lbb00249c-debut(a4)
			beq	lbc001060
			subq.l	#2,lbb00249c-debut(a4)
			jmp	lbc0015ac-debut(a4)
lbc001576		clr.l	lbb00249c
			jmp	lbc0015ac-debut(a4)
lbc001584		add.l	#10,lbb00249c-debut(a4)
			jmp	lbc0015ac-debut(a4)
lbc001592		cmp.l	#10,lbb00249c-debut(a4)
			bcs.b	lbc0015a8
			sub.l	#10,lbb00249c-debut(a4)
lbc0015a8		jmp	lbc0015ac-debut(a4)

lbc0015ac		move.w	lbw00249e-debut(a4),lbw002772-debut(a4)
			move.w	lbw00249e-debut(a4),lbw002776-debut(a4)
			lea.l	lbb00249c-debut(a4),a0
			move.l	#"0000",lbb00248e-debut(a4)
			move.b	#"0",lbb002492-debut(a4)
			lea.l	lbb00248e-debut(a4),a1
			jsr	lbc001500-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#$1f1,d0
			moveq.l	#$2b,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	ascii.msg0-debut(a4),a0
			moveq.l	#4,d0
			callg	text
			move.l	lbb00249c-debut(a4),d0
			lsl.l	#3,d0
			move.l	d0,lbl0024a0-debut(a4)
			lea.l	lbl0024a0-debut(a4),a0
			move.l	#"0000",lbb00248e-debut(a4)
			move.b	#"0",lbb002492-debut(a4)
			lea.l	lbb00248e-debut(a4),a1
			jsr	lbc001500-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#$188,d0
			moveq.l	#$23,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	ascii.msg0-debut(a4),a0
			moveq.l	#4,d0
			callg	text
			jsr	lbc001832-debut(a4)
			jsr	lbc00187c-debut(a4)
			jmp	lbc000ffa-debut(a4)

lbc00164a		move.w	lbw002496-debut(a4),lbw00277a-debut(a4)
			move.w	lbw00249a-debut(a4),lbw00277e-debut(a4)
			lea.l	lbw002494-debut(a4),a0
			move.l	#"0000",lbb00248e-debut(a4)
			move.b	#"0",lbb002492-debut(a4)
			lea.l	lbb00248e-debut(a4),a1
			jsr	lbc001500-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#$1f1,d0
			moveq.l	#$1b,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	ascii.msg0-debut(a4),a0
			moveq.l	#4,d0
			callg	text
			lea.l	lbb002498-debut(a4),a0
			move.l	#"0000",lbb00248e-debut(a4)
			move.b	#"0",lbb002492-debut(a4)
			lea.l	lbb00248e-debut(a4),a1
			jsr	lbc001500-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#$1f1,d0
			moveq.l	#$23,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	ascii.msg0-debut(a4),a0
			moveq.l	#4,d0
			callg	text
			rts

lbc0016cc		cmp.l	#$48,lbb002498-debut(a4)
			bcs	lbc001060
			subq.l	#8,lbb002498-debut(a4)
			jsr	lbc00164a-debut(a4)
			jsr	lbc00171c-debut(a4)
			jsr	lbc001576-debut(a4)
			jmp	lbc00187c-debut(a4)

lbc0016f4		cmp.l	#$d0,lbb002498-debut(a4)
			bcc	lbc001060
			addq.l	#8,lbb002498-debut(a4)
			jsr	lbc00164a-debut(a4)
			jsr	lbc00171c-debut(a4)
			jsr	lbc001576-debut(a4)
			jmp	lbc00187c-debut(a4)

lbc00171c		btst.b	#15,bp_pointeur-debut(a4)
			beq.b	lbc001734
			lea.l	lbl0017c0-debut(a4),a0
			lea.l	lbl00180c-debut(a4),a1
			jmp	lbc001740-debut(a4)

lbc001734		lea.l	lbl0017e6-debut(a4),a1
			lea.l	lbl00179a-debut(a4),a0
lbc001740		moveq.l	#20-1,d0
			moveq.l #0,d1
lbc001748		move.w	(a0),d1
			cmp.l	lbb002498-debut(a4),d1
			bne.b	lbc00175a
			move.w	(a1),lbw00247e-debut(a4)
			jmp	lbc001762-debut(a4)
lbc00175a		addq.l	#2,a0
			addq.l	#2,a1
			dbf	d0,lbc001748

lbc001762		lea.l	lbb00247c-debut(a4),a0
			move.l	#"0000",lbb00248e-debut(a4)
			move.b	#"0",lbb002492-debut(a4)
			lea.l	lbb00248e-debut(a4),a1
			jsr	lbc001500-debut(a4)
			move.l	#$188,d0
			moveq.l	#$1b,d1
			lea.l	rastport-debut(a4),a1
			callg	move
			lea.l	rastport-debut(a4),a1
			moveq.l	#4,d0
			lea.l	ascii.msg0-debut(a4),a0
			callg	text
			rts

lbc001832		move.l	lbb00247c-debut(a4),d0
			add.l	lbl0024a0-debut(a4),d0
			move.l	d0,lbl0024a4-debut(a4)
			lea.l	lbl0024a4-debut(a4),a0
			move.l	#"0000",lbb00248e-debut(a4)
			move.b	#"0",lbb002492-debut(a4)
			lea.l	lbb00248e-debut(a4),a1
			jsr	lbc001500-debut(a4)
			move.l	#$188,d0
			moveq.l	#$2b,d1
			lea.l	rastport-debut(a4),a1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	ascii.msg0-debut(a4),a0
			moveq.l	#4,d0
			callg	text
			rts

lbc00187c		move.l	lbl0024a4-debut(a4),d0
			divu.w	#8,d0
			move.l	d0,lbl002474-debut(a4)
			lea.l	lbl002474-debut(a4),a0
			move.l	#"0000",lbb00248e-debut(a4)
			move.b	#"0",lbb002492-debut(a4)
			lea.l	lbb00248e-debut(a4),a1
			jsr	lbc001500-debut(a4)
			move.l	#196,d0
			moveq.l	#51,d1
			lea.l	rastport-debut(a4),a1
			callg	move
			lea.l	rastport-debut(a4),a1
			moveq.l	#5,d0
			lea.l	byte_mes-debut(a4),a0
			callg	text

			move.l	#196+(6*8),d0
			moveq.l	#51,d1
			lea.l	rastport-debut(a4),a1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	ascii.msg0-debut(a4),a0
			moveq.l	#4,d0
			callg	text
			rts

lbc0018c4		lea.l	lbb0024a8-debut(a4),a0
			move.l	#"0000",lbb00248e-debut(a4)
			move.b	#"0",lbb002492-debut(a4)
			lea.l	lbb00248e-debut(a4),a1
			jsr	lbc001500-debut(a4)
			move.l	#$188,d0
			moveq.l	#$33,d1
			lea.l	rastport-debut(a4),a1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	ascii.msg0-debut(a4),a0
			moveq.l	#4,d0
			callg	text
			rts

* ------------------------------------------------------ place la palette iff *
place_palette_iff	lea.l	lbl002274-debut(a4),a0
			lea.l	palette_iff-debut(a4),a1
			moveq.l	#48-1,d7
efface_palette_iff	clr.w	(a1)+
			dbf	d7,efface_palette_iff
			lea.l	palette_iff-debut(a4),a1
			moveq.l	#0,d0
			move.b	lbb002472-debut(a4),d0
			sub.b	#"0",d0
			lea.l	nbr_cols-debut(a4),a2
			cmp.b	#6,d0
			bne.b	pas_6bps
			subq.b	#1,d0
pas_6bps		add.w	d0,d0
			moveq.l	#0,d7
			move.w	(a2,d0.w),d7
			subq.w	#1,d7
place_palette		move.w	(a0),d0
			lsr.w	#4,d0
			and.w	#$f0,d0
			move.b	d0,(a1)+
			move.w	(a0),d0
			and.w	#$f0,d0
			move.b	d0,(a1)+
			move.w	(a0)+,d0
			lsl.w	#4,d0
			move.b	d0,(a1)+
			dbf	d7,place_palette
			rts

* ------------------------------------------------------------- sauve l'image *
* bit 2 = interlace
* bit 8 = hires
lbc00192a		jsr	place_palette_iff-debut(a4)
			move.l	compteur_bp1-debut(a4),lbl0024ac-debut(a4)
			move.l	compteur_bp2-debut(a4),lbl0024b0-debut(a4)
			move.l	compteur_bp3-debut(a4),lbl0024b4-debut(a4)
			move.l	compteur_bp4-debut(a4),lbl0024b8-debut(a4)
			move.l	compteur_bp5-debut(a4),lbl0024bc-debut(a4)
			move.l	compteur_bp6-debut(a4),lbl0024be-debut(a4)
			move.l	lbl0024a4-debut(a4),d0
			move.l	d0,d3
			asr.l	#3,d3			* /8
			move.l	d3,lbl0024c0-debut(a4)	* largeur
			move.w	lbw0024aa-debut(a4),d1	* longueur
			move.w	d1,long_iff-debut(a4)
			move.w	d0,larg_iff-debut(a4)
			move.w	d1,long_iff2-debut(a4)
			move.w	d0,larg_iff2-debut(a4)
			moveq.l	#0,d2
			move.b	lbb002472-debut(a4),d2
			sub.b	#"0",d2
			move.b	d2,plans_iff-debut(a4)	* nbr de plans
			mulu.w	d1,d3			* longueur * largeur
			mulu.w	d2,d3			* * nbr de plans
			move.l	d3,body_iff-debut(a4)	* longueur de plans
			add.l	#164-8,d3
			move.l	d3,longueur_fichier-debut(a4)
			move.l	#$4000,d0
			tst.b	flag_ham-debut(a4)
			beq.b	pas_ham_iff
			or.l	#$800,d0			* ham
			jmp	pas_halfbrite-debut(a4)
pas_ham_iff		cmp.b	#6,d2
			bne.b	pas_halfbrite
			or.l	#$80,d0				* halfbrite
pas_halfbrite		tst.b	flag_hi-debut(a4)
			beq.b	pas_hi
			or.l	#$8000,d0			* hires
pas_hi			move.l	d0,view_iff-debut(a4)
			move.l	#nom_fichier_mes,d1
			move.l	#$3ee,d2
			calld	open
			tst.l	d0
			beq	lbc001a86
			move.l	d0,lbb002270-debut(a4)
			tst.b	flag_raw-debut(a4)
			bne.b	sauve_raw
			move.l	lbb002270-debut(a4),d1		* struct
			move.l	#struct_iff,d2			* iff
			move.l	#164,d3
			calld	write
			beq.w	lbc001a7c
			jmp	pas_sauve_raw-debut(a4)
sauve_raw		lea.l	nbr_cols-debut(a4),a0
			moveq.l	#0,d0
			move.b	lbb002472-debut(a4),d0
			sub.b	#"0",d0
			cmp.b	#6,d0
			bne.b	pas_6bps_raw
			subq.b	#1,d0
pas_6bps_raw		add.w	d0,d0
			moveq.l	#0,d3
			moveq.l	#0,d7
			move.w	(a0,d0.w),d7
			add.w	d7,d7				* mots
			move.l	d7,d3
			move.l	lbb002270-debut(a4),d1		* juste la
			move.l	#lbl002274,d2			* palette
			calld	write
			beq.w	lbc001a7c
pas_sauve_raw
			moveq.l	#0,d7
			move.w	long_iff-debut(a4),d7
			subq.w	#1,d7
lbc0019f6		move.l	lbl0024ac-debut(a4),d2		* plan1
			jsr	lbc001a88-debut(a4)
			cmp.b	#1,plans_iff-debut(a4)
			beq.b	lbc001a54
			move.l	lbl0024b0-debut(a4),d2		* plan2
			jsr	lbc001a88-debut(a4)
			cmp.b	#2,plans_iff-debut(a4)
			beq.b	lbc001a54
			move.l	lbl0024b4-debut(a4),d2		* plan3
			jsr	lbc001a88-debut(a4)
			cmp.b	#3,plans_iff-debut(a4)
			beq.b	lbc001a54
			move.l	lbl0024b8-debut(a4),d2		* plan4
			jsr	lbc001a88-debut(a4)
			cmp.b	#4,plans_iff-debut(a4)
			beq.b	lbc001a54
			move.l	lbl0024bc-debut(a4),d2		* plan5
			jsr	lbc001a88-debut(a4)
			cmp.b	#5,plans_iff-debut(a4)
			beq.b	lbc001a54
			move.l	lbl0024be-debut(a4),d2		* plan6
			jsr	lbc001a88-debut(a4)
lbc001a54		move.l	lbl0024c0-debut(a4),d0
			add.l	d0,lbl0024ac-debut(a4)
			add.l	d0,lbl0024b0-debut(a4)
			add.l	d0,lbl0024b4-debut(a4)
			add.l	d0,lbl0024b8-debut(a4)
			add.l	d0,lbl0024bc-debut(a4)
			add.l	d0,lbl0024be-debut(a4)
			dbf	d7,lbc0019f6

lbc001a7c		move.l	lbb002270-debut(a4),d1
			calld	close
			move.l	#240,d1
			calld	delay
lbc001a86		rts

lbc001a88		move.l	d7,-(a7)
			move.l	lbb002270-debut(a4),d1	* ecrit 1 ligne
			move.l	lbl0024c0-debut(a4),d3
			calld	write
			beq	lbc001a7c
			move.l	(a7)+,d7
			rts

ecr_100			move.l	#100,lbb0024a8-debut(a4)
			sf.b	$bfec01
			jmp	lbc001b24-debut(a4)
lbc001aa2		move.l	#200,lbb0024a8-debut(a4)
			sf.b	$bfec01
			jmp	lbc001b24-debut(a4)
lbc001ab0		move.l	#256,lbb0024a8-debut(a4)
			sf.b	$bfec01
			jmp	lbc001b24-debut(a4)
ecr_512			move.l	#512,lbb0024a8-debut(a4)
			sf.b	$bfec01
			jmp	lbc001b24-debut(a4)
	
lbc001abe		tst.b	flag-debut(a4)
			bne.b	pas1
			cmp.b	#f6_key,$bfec01		* f6:definis hauteur
			beq.b	lbc001aca
			rts
pas1			cmp.b	#$77,$bfec01		* termine
			beq.b	lbc001aca
			cmp.b	#$75,$bfec01
			bne.b	pass
			move.l	sauve_larg-debut(a4),lbb0024a8-debut(a4)
			jmp	lbc001aca-debut(a4)
pass			rts
		
lbc001aca		eor.b	#1,flag-debut(a4)
			sf.b	$bfec01
			tst.b	lbb0024c8-debut(a4)
			beq	lbc001b48
			not.b	lbb0024c8-debut(a4)
			move.l	pointe_bp1-debut(a4),compteur_bp1-debut(a4)
			move.l	pointe_bp2-debut(a4),compteur_bp2-debut(a4)
			move.l	pointe_bp3-debut(a4),compteur_bp3-debut(a4)
			move.l	pointe_bp4-debut(a4),compteur_bp4-debut(a4)
			move.l	pointe_bp5-debut(a4),compteur_bp5-debut(a4)
			move.l	pointe_bp6-debut(a4),compteur_bp6-debut(a4)
			tst.l	lbb0024a8-debut(a4)
			bne.b	lbc001b24
			move.l	#1,lbb0024a8-debut(a4)
lbc001b24		jsr	lbc001346-debut(a4)
			jsr	lbc0012e2-debut(a4)
			jsr	lbc0018c4-debut(a4)
lbc001b30		moveq.l	#2,d0
			moveq.l	#1,d5
			jsr	defpens-debut(a4)
			jsr	lbc001ba6-debut(a4)
			jmp	lbc000ffa-debut(a4)

lbc001b48		not.b	lbb0024c8-debut(a4)
			move.l	lbb0024a8-debut(a4),sauve_larg-debut(a4)
			move.l	compteur_bp1-debut(a4),pointe_bp1-debut(a4)
			move.l	compteur_bp2-debut(a4),pointe_bp2-debut(a4)
			move.l	compteur_bp3-debut(a4),pointe_bp3-debut(a4)
			move.l	compteur_bp4-debut(a4),pointe_bp4-debut(a4)
			move.l	compteur_bp5-debut(a4),pointe_bp5-debut(a4)
			move.l	compteur_bp6-debut(a4),pointe_bp6-debut(a4)
			clr.l	lbb0024a8-debut(a4)
			jsr	lbc0018c4-debut(a4)
			moveq.l	#1,d0
			moveq.l	#2,d5
			jsr	defpens-debut(a4)
			jsr	lbc001ba6-debut(a4)
			jmp	lbc000ffa-debut(a4)

lbc001ba6		lea.l	rastport-debut(a4),a1
			move.l	#236-(8*3),d0
			moveq.l	#51+8,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	control_mes-debut(a4),a0
			moveq.l	#6,d0
			callg	text
			moveq.l	#2,d0
			moveq.l	#1,d5
			jmp	defpens-debut(a4)

lbc001be4		addq.l	#1,lbb0024a8-debut(a4)
			moveq.l	#100,d4
			movem.l	d0-a6,-(a7)
			jsr	lbc0018c4-debut(a4)
			movem.l	(a7)+,d0-a6
			rts

lbc001bfe		addq.l	#1,lbb0024a8-debut(a4)
			move.l	#4000,d4
			movem.l	d0-a6,-(a7)
			jsr	lbc0018c4-debut(a4)
			movem.l	(a7)+,d0-a6
			rts

lbc001c18		sf.b	$bfec01
			tst.b	lbb0024c9-debut(a4)
			beq.b	lbc001c6c
			moveq.l	#0,d0
			moveq.l	#0,d5
			jsr	defpens-debut(a4)
			lea.l	rastport-debut(a4),a1
			moveq.l	#0,d0
			moveq.l	#3,d1
			move.l	#$c3,d2
			moveq.l	#$32+14,d3
			jsr	-$132(a6)
			moveq.l	#2,d0
			moveq.l	#1,d5
			jsr	defpens-debut(a4)
			not.b	lbb0024c9-debut(a4)
			rts

lbc001c6c		not.b	lbb0024c9-debut(a4)
			moveq.l	#4-1,d2
			lea.l	col_nbr_mes-debut(a4),a2
			moveq.l	#13,d5
lbc001c84		moveq.l	#7,d3
			moveq.l	#2,d4
lbc001c90		lea.l	rastport-debut(a4),a1
			move.l	d5,d1
			move.l	d4,d0
			callg	move
			lea.l	rastport-debut(a4),a1
			moveq.l	#2,d0
			lea.l	(a2),a0
			callg	text
			addq.l	#2,a2
			add.l	#24,d4
			dbf	d3,lbc001c90
			add.l	#14,d5
			dbf	d2,lbc001c84
			rts

* --------------------------------------------------- changement des couleurs *
lbc001cc8		move.l	lbl0024c4-debut(a4),d0
			lea.l	table_co-debut(a4),a0
			moveq.l	#0,d1
			moveq.l	#0,d2
			move.b	lbb002472-debut(a4),d2
			sub.b	#"0",d2
			cmp.b	#6,d2
			blt.b	pas_hautc
			moveq.l	#5,d2
			tst.b	flag_ham-debut(a4)
			beq.b	pas_hautc		* pas du ham
			moveq.l	#4,d2
pas_hautc		move.b	(a0,d2.w),d1
			cmp.l	d1,d0			* ajoute avec enter
			beq	lbc001060
			addq.l	#1,lbl0024c4-debut(a4)
			jmp	lbc001cf8-debut(a4)
lbc001ce0		cmp.l	#1,lbl0024c4-debut(a4)	* retranche avec -
			beq	lbc001060
			subq.l	#1,lbl0024c4-debut(a4)
lbc001cf8		jsr	lbc001d32-debut(a4)
			lea	lbl0024c4-debut(a4),a0
			move.l	#"0000",lbb00248eb-debut(a4)
			move.b	#"0",lbb002492b-debut(a4)
			lea.l	lbb00248eb-debut(a4),a1
			jsr	lbc001500-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#229,d0
			moveq.l	#27,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	lbb002491b-debut(a4),a0
			moveq.l	#2,d0
			callg	text
			tst.b	flag_echange-debut(a4)
			beq.b	pas_echange
			moveq.l	#3,d0
			lea.l	echange2_mes-debut(a4),a0
			move.l	#199,d1
			jmp	place_echange-debut(a4)
pas_echange		tst.b	flag_echange2-debut(a4)
			beq.b	pas_echange2
			moveq.l	#3,d0
			lea.l	echange2_mes+7-debut(a4),a0
			move.l	#199+(8*7),d1
			jmp	place_echange-debut(a4)
pas_echange2
			tst.b	flag_spread-debut(a4)
			beq.b	pas_spread
			moveq.l	#3,d0
			lea.l	spread2_mes-debut(a4),a0
			move.l	#199,d1
			jmp	place_spread-debut(a4)
pas_spread		tst.b	flag_spread2-debut(a4)
			beq.b	pas_spread2
			moveq.l	#3,d0
			lea.l	spread2_mes+7-debut(a4),a0
			move.l	#199+(8*7),d1
			jmp	place_spread-debut(a4)
pas_spread2		rts

lbc001d32		lea	lbw002272-debut(a4),a0
			move.l	lbl0024c4-debut(a4),d0
			add.l	d0,d0
			add.l	d0,a0
			moveq.l #0,d0
			move.w	(a0),lbw002482-debut(a4)
			lea	lbw002480-debut(a4),a0
			jsr	lbc001132-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#251,d0
			moveq.l	#27,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	lbb001177-debut(a4),a0
			moveq.l	#3,d0
			callg	text
			rts
			
lbc001d84		lea.l	sprite_cols-debut(a4),a0
			move.l	#lbb001ef6,d2
			add.l	d0,d2
			move.l	d2,a1
			moveq.l	#0,d2
			move.b	(a1),d2
			add.l	d2,a0
			move.w	d1,(a0)
			lea.l	lbw002786-debut(a4),a0
			add.l	d0,d0
			add.l	d0,d0
			add.l	d0,a0
			move.w	d1,(a0)
			jmp	lbc000ffa-debut(a4)

lbc001db0		moveq.l	#0,d1
			moveq.l	#1,d0
			lea.l	lbl002274-debut(a4),a0
lbc001dbe		move.w	(a0),d1
			movem.l	d0-a6,-(a7)
			jsr	lbc001d84-debut(a4)
			movem.l	(a7)+,d0-a6
			addq.l	#2,a0
			addq.l	#1,d0
			cmp.l	#$21,d0
			bne.b	lbc001dbe
			jmp	lbc000ffa-debut(a4)

col_zero		sf.b	$bfec01
			clr.w	lbw002482-debut(a4)		* clr col
			tst.b	flag_rgb-debut(a4)
			beq.b	pas_rgb_up
			move.w	#$fff,lbw002482-debut(a4)
pas_rgb_up		jsr	lbc001eac-debut(a4)
			eor.b	#1,flag_rgb-debut(a4)
			jmp	lbc001d32-debut(a4)

res_rouge		sf.b	$bfec01
			move.w	lbw002482-debut(a4),d0
			and.w	#$0ff,d0
			tst.b	flag_rouge-debut(a4)
			beq.b	pas_rouge_up
			add.w	#$f00,d0
pas_rouge_up		move.w	d0,lbw002482-debut(a4)		* clr rouge
			jsr	lbc001eac-debut(a4)
			eor.b	#1,flag_rouge-debut(a4)
			jmp	lbc001d32-debut(a4)

res_vert		sf.b	$bfec01
			move.w	lbw002482-debut(a4),d0
			and.w	#$f0f,d0
			tst.b	flag_vert-debut(a4)
			beq.b	pas_vert_up
			add.w	#$0f0,d0
pas_vert_up		move.w	d0,lbw002482-debut(a4)		* clr vert
			jsr	lbc001eac-debut(a4)
			eor.b	#1,flag_vert-debut(a4)
			jmp	lbc001d32-debut(a4)

res_bleu		sf.b	$bfec01
			move.w	lbw002482-debut(a4),d0
			and.w	#$ff0,d0
			tst.b	flag_bleu-debut(a4)
			beq.b	pas_bleu_up
			add.w	#$00f,d0
pas_bleu_up		move.w	d0,lbw002482-debut(a4)		* clr bleu
			jsr	lbc001eac-debut(a4)
			eor.b	#1,flag_bleu-debut(a4)
			jmp	lbc001d32-debut(a4)

lbc001ddc		move.w	lbw002482-debut(a4),d0
			and.w	#$f00,d0
			cmp.w	#$f00,d0
			beq	lbc001060
			add.w	#$100,lbw002482-debut(a4)	* + rouge
			jsr	lbc001eac-debut(a4)
			jmp	lbc001d32-debut(a4)

lbc001e00		move.w	lbw002482-debut(a4),d0
			and.w	#$f00,d0
			beq	lbc001060
			sub.w	#$100,lbw002482-debut(a4)	* - rouge
			jsr	lbc001eac-debut(a4)
			jmp	lbc001d32-debut(a4)

lbc001e24		move.w	lbw002482-debut(a4),d0
			and.w	#$f0,d0
			cmp.w	#$f0,d0
			beq	lbc001060
			add.w	#$10,lbw002482-debut(a4)	* + vert
			jsr	lbc001eac-debut(a4)
			jmp	lbc001d32-debut(a4)

lbc001e46		move.w	lbw002482-debut(a4),d0
			and.w	#$f0,d0
			beq	lbc001060
			sub.w	#$10,lbw002482-debut(a4)	* - vert
			jsr	lbc001eac-debut(a4)
			jmp	lbc001d32-debut(a4)

lbc001e68		move.w	lbw002482-debut(a4),d0
			and.w	#$f,d0
			cmp.w	#$f,d0
			beq	lbc001060
			addq.w	#1,lbw002482-debut(a4)		* + bleu
			jsr	lbc001eac-debut(a4)
			jmp	lbc001d32-debut(a4)

lbc001e8a		move.w	lbw002482-debut(a4),d0
			and.w	#$f,d0
			beq	lbc001060
			subq.w	#1,lbw002482-debut(a4)		* - bleu
			jsr	lbc001eac-debut(a4)
			jmp	lbc001d32-debut(a4)

lbc001eac		lea	lbw002272-debut(a4),a0
			move.l	lbl0024c4-debut(a4),d0
			add.l	d0,d0
			add.l	d0,a0
			move.w	lbw002482-debut(a4),(a0)
			jmp	lbc001db0-debut(a4)

lbc001eca		move.l	compteur_bp1-debut(a4),d0
			move.l	d0,compteur_bp2-debut(a4)
			move.l	d0,compteur_bp3-debut(a4)
			move.l	d0,compteur_bp4-debut(a4)
			move.l	d0,compteur_bp5-debut(a4)
			move.l	d0,compteur_bp6-debut(a4)
			jsr	lbc0012e2-debut(a4)
			jsr	lbc001346-debut(a4)
			jmp	lbc000ffa-debut(a4)

ham			tst.b	flag_ham-debut(a4)
			beq.b	deja
			jmp	aga_ham-debut(a4)
deja			rts

change_ham		move.l	#1,lbl0024c4-debut(a4)
			jsr	lbc001cf8-debut(a4)
			sf.b	$bfec01
			btst	#15,bp_pointeur-debut(a4)	* hires
			bne.b	pas
aga_ham			lea.l	bp_pointeur-debut(a4),a0
			bchg.b	#11,(a0)
			lea.l	rastport-debut(a4),a1
			move.l	#505-8,d0
			moveq.l	#59,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	hb_mes-debut(a4),a0
			tst.b	flag_ham-debut(a4)
			bne.b	pas_ham
			lea.l	ham_mes-debut(a4),a0
pas_ham			moveq.l	#4,d0
			callg	text
			eor.b	#1,flag_ham-debut(a4)
pas			rts

default			lea.l	def_pal-debut(a4),a0
			lea.l	lbl002274-debut(a4),a1
			lea.l	lbl000720-debut(a4),a2
			lea.l	palette+2-debut(a4),a3
			moveq.l	#32-1,d7
copy_palette		move.w	(a0),(a1)+
			move.w	(a0),(a2)+
			move.w	(a0)+,(a3)
			addq.l	#4,a3
			dbf	d7,copy_palette
			lea.l	def_pal-debut(a4),a0
			lea.l	spr_palette1+6-debut(a4),a1
			lea.l	spr_palette2+6-debut(a4),a2
			lea.l	spr_palette3+6-debut(a4),a3
			lea.l	spr_palette4+6-debut(a4),a5
			moveq.l	#8-1,d7
copy_palette2		move.w	(8*6)(a0),(a5)
			move.w	(8*4)(a0),(a3)
			move.w	(8*2)(a0),(a2)
			move.w	(a0)+,(a1)
			addq.l	#4,a1
			addq.l	#4,a2
			addq.l	#4,a3
			addq.l	#4,a5
			dbf	d7,copy_palette2
			jsr	lbc001cf8-debut(a4)
			jmp	lbc000ffa-debut(a4)

change_format		sf.b	$bfec01
			lea.l	rastport-debut(a4),a1
			move.l	#433-(8*4),d0
			moveq.l	#59,d1
			callg	move
			lea.l	rastport-debut(a4),a1
			lea.l	raw_mes-debut(a4),a0
			tst.b	flag_raw
			beq.w	pas_raw
			lea.l	iff_mes-debut(a4),a0
pas_raw			moveq.l	#3,d0
			callg	text
			eor.b	#1,flag_raw
			rts

put_50000		sf.b	$bfec01
			move.l	#$50000,d0
			tst.b	flag_chip1-debut(a4)
			beq.b	pas_1mb1
			move.l	#$d0000,d0
pas_1mb1		tst.b	flag_chip2-debut(a4)
			beq.b	pas_2mb1
			move.l	#$150000,d0
pas_2mb1		move.l	d0,compteur_bp1-debut(a4)
			move.l	d0,compteur_bp2-debut(a4)
			move.l	d0,compteur_bp3-debut(a4)
			move.l	d0,compteur_bp4-debut(a4)
			move.l	d0,compteur_bp5-debut(a4)
			move.l	d0,compteur_bp6-debut(a4)
			jsr	lbc0012e2-debut(a4)
			jsr	lbc001346-debut(a4)
			jmp	lbc000ffa-debut(a4)

put_00000		sf.b	$bfec01
			moveq.l	#0,d0
			tst.b	flag_chip1-debut(a4)
			beq.b	pas_1mb
			move.l	#$80000,d0
pas_1mb			tst.b	flag_chip2-debut(a4)
			beq.b	pas_2mb
			move.l	#$100000,d0
pas_2mb			move.l	d0,compteur_bp1-debut(a4)
			move.l	d0,compteur_bp2-debut(a4)
			move.l	d0,compteur_bp3-debut(a4)
			move.l	d0,compteur_bp4-debut(a4)
			move.l	d0,compteur_bp5-debut(a4)
			move.l	d0,compteur_bp6-debut(a4)
			jsr	lbc0012e2-debut(a4)
			jsr	lbc001346-debut(a4)
			jmp	lbc000ffa-debut(a4)

help_txt		sf.b	$bfec01
			rts

* ----------------------------------------------------------------- swap mode *
echange			sf.b	$bfec01
			tst.b	flag_echange3-debut(a4)
			bne.w	echange_valide
			st.b	flag_echange3-debut(a4)
			tst.b	flag_echange2-debut(a4)
			bne.w	deja_echange
			tst.b	flag_echange-debut(a4)
			bne.w	deja_echange
			st.b	flag_echange-debut(a4)
			moveq.l	#3,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#197,d0
			moveq.l	#43-8,d1
			callg	move
			moveq.l	#9,d0
			lea.l	vide_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			lea.l	rastport-debut(a4),a1
			move.l	#199+4,d0
			moveq.l	#43-8,d1
			callg	move
			moveq.l	#9,d0
			lea.l	echange_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199,d0
			moveq.l	#43,d1
			callg	move
			moveq.l	#9,d0
			lea.l	vide_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			lea.l	rastport-debut(a4),a1
			move.l	#199+(8*2),d0
			moveq.l	#43,d1
			callg	move
			lea.l	echange2_mes+2-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			moveq.l	#4,d0
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			moveq.l	#3,d0
			lea.l	echange2_mes-debut(a4),a0
			move.l	#199,d1
place_echange		move.l	a0,ptr-debut(a4)
			move.l	d1,pos-debut(a4)
			lea.l	(a0),a1
			lea.l	lbb002491b-debut(a4),a0
			move.b	(a0)+,(a1)+
			move.b	(a0),(a1)
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	pos-debut(a4),d0
			moveq.l	#43,d1
			callg	move
			moveq.l	#2,d0
			move.l	ptr-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			moveq.l	#2,d0
			jmp	defpena-debut(a4)
deja_echange		rts

echange_valide		sf.b	$bfec01
			cmp.b	#1,flag_cont-debut(a4)
			bne.w	pas_cont2
			sf.b	flag_cont-debut(a4)
			sf.b	flag_echange2-debut(a4)
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199+(7*8),d0
			moveq.l	#43,d1
			callg	move
			lea.l	echange2_mes+7-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			moveq.l	#2,d0
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			lea.l	echange2_mes-debut(a4),a0
			jsr	long_conv-debut(a4)
			move.b	d0,chiffre1-debut(a4)
			lea.l	echange2_mes+7-debut(a4),a0
			jsr	long_conv-debut(a4)
			move.b	d0,chiffre2-debut(a4)
			moveq.l	#0,d0
			moveq.l	#0,d1
			move.b	chiffre1-debut(a4),d0
			move.b	chiffre2-debut(a4),d1
			subq.b	#1,d0
			subq.b	#1,d1
			add.w	d0,d0
			add.w	d1,d1
			lea.l	lbl002274-debut(a4),a0
			move.w	(a0,d0.w),d2
			move.w	(a0,d1.w),d3
			move.w	d3,(a0,d0.w)
			move.w	d2,(a0,d1.w)
			lea.l	lbl002274-debut(a4),a1
			lea.l	lbl000720-debut(a4),a2
			lea.l	palette+2-debut(a4),a3
			moveq.l	#32-1,d7
copy_palette_echange	move.w	(a1),(a2)+
			move.w	(a1)+,(a3)
			addq.l	#4,a3
			dbf	d7,copy_palette_echange
			lea.l	lbl002274-debut(a4),a0
			lea.l	spr_palette1+6-debut(a4),a1
			lea.l	spr_palette2+6-debut(a4),a2
			lea.l	spr_palette3+6-debut(a4),a3
			lea.l	spr_palette4+6-debut(a4),a5
			moveq.l	#8-1,d7
copy_palette2_echange	move.w	(8*6)(a0),(a5)
			move.w	(8*4)(a0),(a3)
			move.w	(8*2)(a0),(a2)
			move.w	(a0)+,(a1)
			addq.l	#4,a1
			addq.l	#4,a2
			addq.l	#4,a3
			addq.l	#4,a5
			dbf	d7,copy_palette2_echange
			jsr	lbc001cf8-debut(a4)
			jsr	lbc000ffa-debut(a4)
			sf.b	flag_echange3-debut(a4)
			jmp	vire_swap-debut(a4)

pas_cont2		tst.b	flag_echange-debut(a4)
			beq.w	deja_valide_swap
			sf.b	flag_echange-debut(a4)
			st.b	flag_echange2-debut(a4)
			moveq.l	#2,d0
			lea.l	echange2_mes-debut(a4),a0
			move.l	#199,d1
			jsr	place_echange-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199,d0
			moveq.l	#43,d1
			callg	move
			lea.l	echange2_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			moveq.l	#7,d0
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			lea.l	lbb002491b-debut(a4),a0
			lea.l	echange2_mes+7-debut(a4),a1
			move.b	(a0)+,(a1)+
			move.b	(a0),(a1)
			moveq.l	#3,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199+(7*8),d0
			moveq.l	#43,d1
			callg	move
			lea.l	echange2_mes+7-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			moveq.l	#2,d0
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			addq.b	#1,flag_cont-debut(a4)
			rts

vire_swap		moveq.l	#3,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199,d0
			moveq.l	#43-8,d1
			callg	move
			moveq.l	#9,d0
			lea.l	vide_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199,d0
			moveq.l	#43,d1
			callg	move
			moveq.l	#9,d0
			lea.l	vide_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
deja_valide_swap	rts

* --------------------------------------------------------------- spread mode *
spread			sf.b	$bfec01
			tst.b	flag_spread3-debut(a4)
			bne.w	spread_valide
			st.b	flag_spread3-debut(a4)
			tst.b	flag_spread2-debut(a4)
			bne.w	deja_spread
			tst.b	flag_spread-debut(a4)
			bne.w	deja_spread
			st.b	flag_spread-debut(a4)
			moveq.l	#3,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#197,d0
			moveq.l	#43-8,d1
			callg	move
			moveq.l	#9,d0
			lea.l	vide_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			lea.l	rastport-debut(a4),a1
			move.l	#199+4,d0
			moveq.l	#43-8,d1
			callg	move
			moveq.l	#9,d0
			lea.l	spread_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199,d0
			moveq.l	#43,d1
			callg	move
			moveq.l	#9,d0
			lea.l	vide_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			lea.l	rastport-debut(a4),a1
			move.l	#199+(8*2),d0
			moveq.l	#43,d1
			callg	move
			lea.l	spread2_mes+2-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			moveq.l	#4,d0
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			moveq.l	#3,d0
			lea.l	spread2_mes-debut(a4),a0
			move.l	#199,d1
place_spread		move.l	a0,ptr-debut(a4)
			move.l	d1,pos-debut(a4)
			lea.l	(a0),a1
			lea.l	lbb002491b-debut(a4),a0
			move.b	(a0)+,(a1)+
			move.b	(a0),(a1)
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	pos-debut(a4),d0
			moveq.l	#43,d1
			callg	move
			moveq.l	#2,d0
			move.l	ptr-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			moveq.l	#2,d0
			jmp	defpena-debut(a4)
deja_spread		rts

spread_valide		sf.b	$bfec01
			cmp.b	#1,flag_cont-debut(a4)
			bne.w	pas_cont2_spread
			sf.b	flag_cont-debut(a4)
			sf.b	flag_spread2-debut(a4)
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199+(7*8),d0
			moveq.l	#43,d1
			callg	move
			lea.l	spread2_mes+7-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			moveq.l	#2,d0
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			lea.l	spread2_mes-debut(a4),a0
			jsr	long_conv-debut(a4)
			move.b	d0,chiffre1-debut(a4)
			lea.l	spread2_mes+7-debut(a4),a0
			jsr	long_conv-debut(a4)
			move.b	d0,chiffre2-debut(a4)

			clr.l	pos_spread-debut(a4)
			moveq.l	#0,d0
			moveq.l	#0,d1
			move.b	chiffre1-debut(a4),d0
			move.b	chiffre2-debut(a4),d1
			move.l	d0,d4
			move.l	d1,d5
			sub.l	d5,d4
			beq.w	pas_delta
			bgt.b	delta_positif
			neg.l	d4
delta_positif		subq.l	#1,d4
			beq.w	pas_delta
			addq.l	#1,d4
			move.l	d4,delta-debut(a4)

			subq.l	#2,d4
			move.l	d4,d7

copy_spread		move.l	d7,-(a7)
			moveq.l	#0,d0
			moveq.l	#0,d1
			move.b	chiffre1-debut(a4),d0
			move.b	chiffre2-debut(a4),d1
			subq.b	#1,d0
			subq.b	#1,d1
			add.l	pos_spread-debut(a4),d0
			add.w	d0,d0
			add.w	d1,d1
			lea.l	lbl002274-debut(a4),a0
			move.w	(a0,d0.w),d2
			move.w	d2,valeur-debut(a4)
			move.w	(a0,d1.w),d3
			moveq.l	#0,d1
			cmp.w	d3,d2
			bge.b	ok_pos
			moveq.l	#-1,d1
ok_pos
			move.w	d2,d4			* 1ere couleur
			move.w	d2,d5
			and.w	#$f00,d2
			and.w	#$f0,d4
			and.w	#$f,d5

			move.w	d3,d6			* 2eme
			move.w	d3,d7
			and.w	#$f00,d3
			and.w	#$f0,d6
			and.w	#$f,d7

			sub.w	d3,d2			* rouge
			bge.b	ok_rouge
			neg.w	d2
ok_rouge		sub.w	d4,d6			* vert
			bge.b	ok_vert
			neg.w	d6
ok_vert			sub.w	d5,d7			* bleu
			bge.b	ok_bleu
			neg.w	d7
ok_bleu		
			move.l	delta-debut(a4),d0
			beq.b	pas_divu

			moveq.l	#0,d4
			moveq.l	#0,d3
			moveq.l	#0,d5
			move.w	d2,d4
			move.w	d6,d3
			move.w	d7,d5
			ror.w	#8,d4
			ror.b	#4,d3
			divu.w	d0,d4
			divu.w	d0,d3
			divu.w	d0,d5
			ror.w	#8,d4
			ror.b	#4,d3
			move.w	d4,d2
			move.w	d3,d6
			move.w	d5,d7
pas_divu
			move.w	valeur-debut(a4),d5
			or.w	d6,d2
			or.w	d7,d2
			tst.l	d1
			bne.b	ok_positif
			sub.w	d2,d5
			jmp	pas_positif-debut(a4)
ok_positif		add.w	d2,d5
pas_positif
			moveq.l	#0,d0
			move.b	chiffre1-debut(a4),d0
			add.l	pos_spread-debut(a4),d0
			add.w	d0,d0
			lea.l	lbl002274-debut(a4),a0
			move.w	d5,(a0,d0.w)
			addq.l	#1,pos_spread-debut(a4)
			move.l	(a7)+,d7
			dbf	d7,copy_spread


pas_delta		lea.l	lbl002274-debut(a4),a1
			lea.l	lbl000720-debut(a4),a2
			lea.l	palette+2-debut(a4),a3
			moveq.l	#32-1,d7
copy_palette_spread	move.w	(a1),(a2)+
			move.w	(a1)+,(a3)
			addq.l	#4,a3
			dbf	d7,copy_palette_spread
			lea.l	lbl002274-debut(a4),a0
			lea.l	spr_palette1+6-debut(a4),a1
			lea.l	spr_palette2+6-debut(a4),a2
			lea.l	spr_palette3+6-debut(a4),a3
			lea.l	spr_palette4+6-debut(a4),a5
			moveq.l	#8-1,d7
copy_palette2_spread	move.w	(8*6)(a0),(a5)
			move.w	(8*4)(a0),(a3)
			move.w	(8*2)(a0),(a2)
			move.w	(a0)+,(a1)
			addq.l	#4,a1
			addq.l	#4,a2
			addq.l	#4,a3
			addq.l	#4,a5
			dbf	d7,copy_palette2_spread
			jsr	lbc001cf8-debut(a4)
			jsr	lbc000ffa-debut(a4)
			sf.b	flag_spread3-debut(a4)
			jmp	vire_spread-debut(a4)

pas_cont2_spread	tst.b	flag_spread-debut(a4)
			beq.w	deja_valide_spread
			sf.b	flag_spread-debut(a4)
			st.b	flag_spread2-debut(a4)
			moveq.l	#2,d0
			lea.l	spread2_mes-debut(a4),a0
			move.l	#199,d1
			jsr	place_spread-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199,d0
			moveq.l	#43,d1
			callg	move
			lea.l	spread2_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			moveq.l	#7,d0
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			lea.l	lbb002491b-debut(a4),a0
			lea.l	spread2_mes+7-debut(a4),a1
			move.b	(a0)+,(a1)+
			move.b	(a0),(a1)
			moveq.l	#3,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199+(7*8),d0
			moveq.l	#43,d1
			callg	move
			lea.l	spread2_mes+7-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			moveq.l	#2,d0
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			addq.b	#1,flag_cont-debut(a4)
			rts

vire_spread		moveq.l	#3,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199,d0
			moveq.l	#43-8,d1
			callg	move
			moveq.l	#9,d0
			lea.l	vide_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
			moveq.l	#2,d0
			jsr	defpena-debut(a4)
			lea.l	rastport-debut(a4),a1
			move.l	#199,d0
			moveq.l	#43,d1
			callg	move
			moveq.l	#9,d0
			lea.l	vide_mes-debut(a4),a0
			lea.l	rastport-debut(a4),a1
			callg	text
deja_valide_spread	rts

* ---------------------- conversion d'une chaine ascii decimale en 1 long mot *
* entree: (block du nombre en a0)
* sortie: (nombre en d0)
long_conv		movem.l	d1/a0,-(a7)
			moveq.l	#0,d0
conv			cmp.b	#"9",(a0)
			bhi.b	pas_decimal
			cmp.b	#"0",(a0)
			bcs.b	pas_decimal
			add.l	d0,d0
			move.l	d0,d1
			add.l	d0,d0
			add.l	d0,d0
			add.l	d1,d0
			move.b	(a0)+,d1
			and.l	#$f,d1
			add.l	d1,d0
			jmp	conv-debut(a4)
pas_decimal		movem.l	(a7)+,d1/a0
			rts

* ----------------------------------------------------------------- variables *
sauve_col		dc.w	0
flag_chip1		dc.b	0
flag_chip2		dc.b	0
lbl00179a		dc.l	$d000c8,$c000b8,$b000a8,$a00098,$900088,$800078
			dc.l	$700068,$600058,$500048
			dc.w	$40
lbl0017c0		dc.l	$d400cc,$c400bc,$b400ac,$a4009c,$94008c,$84007c
			dc.l	$74006c,$64005c,$54004c
			dc.w	$44
lbl0017e6		dc.l	$1400130,$1200110,$10000f0,$e000d0,$c000b0,$a00090
			dc.l	$800070,$600050,$400030
			dc.w	$20
lbl00180c		dc.l	$2800260,$2400220,$20001e0,$1c001a0,$1800160
			dc.l	$1400120,$10000e0,$c000a0,$800060
			dc.w	$40
flag_hi			dc.b	0
			even
lbb000572		dc.b	$7b,f3_key,f4_key,$87
			dc.b	$33,$37,$99,$9b
			dc.b	$9d,$97,$95,$ef
			dc.b	$85,$a5,$83,$a3
			dc.b	$81,$a1,$79,$6b
			dc.b	$7f,$8d,$8f,$8b
			dc.b	$91,$93,$cb,$c9
			dc.b	$f1,f1_key,f5_key,f2_key
			dc.b	d_key,f7_key,f8_key,f9_key
 			dc.b	$c5,$c3,$c1,$e1,help_key
			dc.b	exg_key,spread_key
lbb00058f		dc.b	43
			even
lbl000590		dc.l	lbc000eee,lbc001aa2,lbc001ab0,lbc001c18
			dc.l	lbc00066a,lbc0006c2,lbc00097e,lbc0008c0
			dc.l	lbc000760,lbc000b9c,lbc000b94,lbc001eca
			dc.l	lbc001ddc,lbc001e00,lbc001e24,lbc001e46
			dc.l	lbc001e68,lbc001e8a,lbc001cc8,lbc001ce0
			dc.l	lbc00149a,lbc001554,lbc00155e,lbc001576
			dc.l	lbc001584,lbc001592,lbc0016cc,lbc0016f4
			dc.l	lbc000652,change_ham,ecr_512,ecr_100
			dc.l	default,change_format,put_00000,put_50000
			dc.l	res_rouge,res_vert,res_bleu,col_zero
			dc.l	help_txt,echange,spread
lbb001ef6		dc.b	0,2,6,10,14,$12,$16,$1a,$1e,$26,$2a,$2e,$32,$36,$3a
			dc.b	$3e,$42,$4a,$4e,$52,$56,$5a,$5e,$62,$66,$6e,$72,$76
			dc.b	$7a,$7e,$82,$86,$8a
			even
lbl000712		dc.l	$22000
lbl000716		dc.l	0
_bitplanepointeur	dc.l	0
			dc.b	$31
lbb00071f		dc.b	7
def_pal			dc.w	$0000,$0e60,$0d50,$0c40,$0b30,$0a20,$0910,$0800
			dc.w	$00f7,$00e6,$00d5,$00c4,$00b3,$00a2,$0091,$0080
			dc.w	$0f7f,$0e6e,$0d5d,$0c4c,$0b3b,$0a2a,$0919,$0808
			dc.w	$007f,$006e,$005d,$004c,$003b,$002a,$0019,$0008

lbw002272		dc.w	0
lbl002274		dc.w	$0000,$0e60,$0d50,$0c40,$0b30,$0a20,$0910,$0800
			dc.w	$00f7,$00e6,$00d5,$00c4,$00b3,$00a2,$0091,$0080
			dc.w	$0f7f,$0e6e,$0d5d,$0c4c,$0b3b,$0a2a,$0919,$0808
			dc.w	$007f,$006e,$005d,$004c,$003b,$002a,$0019,$0008

lbl000720		dc.w	$0000,$0e60,$0d50,$0c40,$0b30,$0a20,$0910,$0800
			dc.w	$00f7,$00e6,$00d5,$00c4,$00b3,$00a2,$0091,$0080
			dc.w	$0f7f,$0e6e,$0d5d,$0c4c,$0b3b,$0a2a,$0919,$0808
			dc.w	$007f,$006e,$005d,$004c,$003b,$002a,$0019,$0008
nbr_cols		dc.w	0,2,4,8,16,32
_adrcopper		dc.l	0

lbl001f56		dc.l	0
			dc.w	2,12
			dc.w	347,46
			dc.w	0,0
			dc.l	gadget		* gadget
			dc.l	bord_picture	* bord picture *
			dc.l	sauvepic_txt
			dc.w	0,0
			dcb.l	20,0

gadget			dc.l	lbl0020f2
			dc.w	5,16
			dc.w	282,10
			dc.w	0,1,4
			dc.l	bord_nom	* bord nom *
			dc.w	0,0,0,0,0,0
			dc.l	lbl002040	* input nom *
			dc.w	1,0,0

lbl002040		dc.l	nom_fichier_mes,0,33,0,0,0,0,0,0

lbl002188		dc.l	0
			dc.w	57,28,58,13
			dc.l	1
			dc.w	1
			dc.l	bord_save	* bord save *
			dc.w	0,0
			dc.l	sauve_txt
			dc.w	0,0,0,0,2,0,0
lbl0020f2		dc.l	lbl002188
			dc.w	174,28,58,13
			dc.l	1
			dc.w	1
			dc.l	bord_save	* bord cancel
			dc.w	0,0
			dc.l	cancel_txt
			dc.w	0,0,0,0,2,0,0

bord_picture		dc.w	3,1
			dc.b	2,1,1,3
			dc.l	coords_picture+8,bord_pictureb
bord_pictureb		dc.w	3,1
			dc.b	1,1,1,3
			dc.l	coords_picture,bord_picture2

bord_picture2		dc.w	4,1
			dc.b	2,1,1,3
			dc.l	coords_pictureb+8,bord_picture2b
bord_picture2b		dc.w	4,1
			dc.b	1,1,1,3
			dc.l	coords_pictureb,0

bord_nom		dc.w	-2,-1
			dc.b	2,1,1,3
			dc.l	coords_picture2,bord_nomb
bord_nomb		dc.w	-2,-1
			dc.b	1,1,1,3
			dc.l	coords_picture2+8,bord_nom2

bord_nom2		dc.w	-3,-1
			dc.b	2,1,1,3
			dc.l	coords_picture3,bord_nom2b
bord_nom2b		dc.w	-3,-1
			dc.b	1,1,1,3
			dc.l	coords_picture3+8,0

bord_save		dc.w	2,1
			dc.b	2,1,1,3
			dc.l	coords_save+8,bord_saveb
bord_saveb		dc.w	2,1
			dc.b	1,1,1,3
			dc.l	coords_save,bord_save2

bord_save2		dc.w	1,1
			dc.b	2,1,1,3
			dc.l	coords_save2+8,bord_save2b
bord_save2b		dc.w	1,1
			dc.b	1,1,1,3
			dc.l	coords_save2,0

coords_picture		dc.w	-1,10,282,10,282,-1,-1,-1,-1,10,-1
coords_pictureb		dc.w	-1,10,280,10,280,-1,-1,-1,-1,10,-1

coords_picture2		dc.w	-1,10,282,10,282,-1,-1,-1,-1,10,-1
coords_picture3		dc.w	-1,10,284,10,284,-1,-1,-1,-1,10,-1
coords_save		dc.w	-1,11,54,11,54,-1,-1,-1,-1,11,-1
coords_save2		dc.w	-1,11,56,11,56,-1,-1,-1,-1,11,-1

sauvepic_txt		dc.b	1,1,0,0
			dc.w	94,3
			dc.l	0,sauvepic_mes,0
sauve_txt		dc.b	1,1,0,0
			dc.w	13,3
			dc.l	0,sauve_mes,0
cancel_txt		dc.b	1,1,0,0
			dc.w	5,3
			dc.l	0,cancel_mes,0
lbb002270		dc.b	0,0
			dc.w	0,0

* ------------------------------------------------------------- structure iff *
struct_iff		dc.b	"FORM"
longueur_fichier	dc.l	0
			dc.b	"ILBMBMHD"
			dc.l	20
larg_iff		dc.w	0
long_iff		dc.w	0
			dc.l	0
plans_iff		dc.b	0,0
			dc.w	0
			dc.w	0
			dc.b	10,11
larg_iff2		dc.w	0
long_iff2		dc.w	0
			dc.b	"CMAP"
ham_iff			dc.l	96
palette_iff		dcb.w	48,0
			dc.b	"CAMG"
			dc.l	4
view_iff		dc.l	0
			dc.b	"BODY"
body_iff		dc.l	0

* --------------------------------------------------------------------------- *
_lock_handle		dc.l	0
_windowbase		dc.l	0
returnmsg		dc.l	0
userport		dc.l	0
lbl002354		dc.l	0
fenetre			dc.w	348,0,292,56
			dc.b	0,1
			dc.l	$560,$1006
			dc.l	0,0
			dc.l	titre_fenetre_mes
			dc.l	0,0
			dc.w	0,0,0,0
			dc.w	1			* workbench window
rastport		dc.l	0
r_bitmap		dcb.l	21,0
			dc.w	0
bitmap			dc.l	$54003c,$ff02ffff
text_plan1		dc.l	0
text_plan2		dc.l	0
			dcb.l	4,0
old_copper		dc.l	0
_adrtext1		dc.l	0
_adrtext2		dc.l	0
			dc.w	0,0,0,0,0
_adrsprite		dc.l	0
_spritelohi		dc.b	0,0
lbw002432		dc.w	0
lbl002434		dc.l	$800
lbl002438		dc.l	$800
lbl00243c		dc.l	$2710

_gfxbase		dc.l	0
_dosbase		dc.l	0
_intbase		dc.l	0
_textfont		dc.l	0
font			dc.l	fontname
			dc.w	8
			dc.b	0,1
			even
compteur_bp1		dc.l	0
compteur_bp2		dc.l	0
compteur_bp3		dc.l	0
compteur_bp4		dc.l	0
compteur_bp5		dc.l	0
compteur_bp6		dc.l	0

pointe_bp1		dc.l	0
pointe_bp2		dc.l	0
pointe_bp3		dc.l	0
pointe_bp4		dc.l	0
pointe_bp5		dc.l	0
pointe_bp6		dc.l	0

lbl002468		dc.b	$ff,$ff,$ff,$ff,$ff,$ff
lbb00246c		dc.b	$ff
ascii.msg		dc.b	0,0,0,0,0,0
			even
rapide			dc.w	0	
old			dc.l	0
lbb002472		dc.b	"6"
lbb002473		dc.b	"6"
lbl002474		dc.l	$28
lbl002478		dc.l	$1f40
lbb00247c		dc.b	0,0
lbw00247e		dc.w	0
lbw002480		dc.w	0
lbw002482		dc.w	0,0,0,0,0,0
lbb00248e		dc.b	0
ascii.msg0		dc.b	0
			dc.b	0
lbb002491		dc.b	"0"
lbb002492		dc.b	0,0
lbb00248eb		dc.b	0
ascii.msg0b		dc.b	0
			dc.b	0
lbb002491b		dc.b	"0"
lbb002492b		dc.b	0,0
			even
lbw002494		dc.w	0
lbw002496		dc.w	$38
lbb002498		dc.b	0,0
lbw00249a		dc.w	$d0
lbb00249c		dc.b	0,0
lbw00249e		dc.w	0
lbl0024a0		dc.l	0
lbl0024a4		dc.l	0
lbb0024a8		dc.b	0,0
lbw0024aa		dc.w	$c8

lbl0024ac		dc.l	0
lbl0024b0		dc.l	0
lbl0024b4		dc.l	0
lbl0024b8		dc.l	0
lbl0024bc		dc.l	0
lbl0024be		dc.l	0

lbl0024c0		dc.l	0

lbl0024c4		dc.l	1
flag_ham		dc.b	0
flag_raw		dc.b	0
lbb0024c8		dc.b	0
lbb0024c9		dc.b	0
mask			dc.l	$7ffff
flag			dc.b	0
			even
sauve_larg		dc.l	0
nbr_co			dc.l	0
table_co		dc.b	1,2,4,8,16,32
flag_echange		dc.b	0
flag_echange2		dc.b	0
flag_echange3		dc.b	0
flag_spread		dc.b	0
flag_spread2		dc.b	0
flag_spread3		dc.b	0
flag_cont		dc.b	0
chiffre1		dc.b	0
chiffre2		dc.b	0
flag_rouge		dc.b	0
flag_vert		dc.b	0
flag_bleu		dc.b	0
flag_rgb		dc.b	0
			even
ptr			dc.l	0
pos			dc.l	0
delta			dc.l	0
pos_spread		dc.l	0
valeur			dc.w	0

* ---------------------------------------------------------------- les textes *
_gfxname		gfxname
_dosname		dosname
_intname		intname
fontname		dc.b	"topaz.font",0
nom_fichier_mes		dc.b	"picture.pic",0
			dcb.b	142,0
control_mes		dc.b	"HANDLE"
bps_pointer_mes		dc.b	"BITPLANE POINTER"
struct_bp_mes		dc.b	"1 OFF ** $000000"
nbr_bps_mes		dc.b	"123456"
bp_ok_mes		dc.b	"**"
bp_no_mes		dc.b	"--"
bp_on_mes		dc.b	"ON "
bp_off_mes		dc.b	"OFF"
sauvepic_mes		dc.b	"SAVE PICTURE",0
cancel_mes		dc.b	"CANCEL",0
sauve_mes		dc.b	"SAVE",0
procname		dc.b	"SEARCHER",0
titre_fenetre_mes	dc.b	"WRITTEN BY FLASHER JACK",0
already_mes		dc.b	"FILE ALREADY EXIST!",0
overwrite_mes		dc.b	"OVERWRITE???",0
byte_mes		dc.b	"BYTES"
iff_mes			dc.b	"IFF"
raw_mes			dc.b	"RAW"
view_mes		dc.b	"VIEW   LORES"
			dc.b	"BITPLANES 00"
			dc.b	"DDFSTRT 0056"
			dc.b	"DDFSTOP 0208"
			dc.b	"MODULO  0000"
			dc.b	"SPEED   0000"
			dc.b	"DISPLAY HALF"
hb_mes			dc.b	"HALF"
ham_mes			dc.b	" HAM"
hi_mes			dc.b	"HI"
lo_mes			dc.b	"LO"
viewdim_mes		dc.b	"VIEW    WIDTH"
			dc.b	"MODULO  WIDTH"
			dc.b	"SCREEN  WIDTH"
			dc.b	"BPLANE HEIGHT"
			dc.b	"SAVE PICTURES"
titre_mes		dc.b	"SEARCHER V2.3 (C)SCOOPEX"
adr_col_mes		dc.b	"ADR:"
search_mes		dc.b	"SEARCHING",0
trouve_mes		dc.b	" FOUND!! ",0
rien_mes		dc.b	" NOTHING ",0
break_mes		dc.b	" BREAK!! ",0
vide_mes		dc.b	"         ",0
echange_mes		dc.b	"  SWAP   ",0
echange2_mes		dc.b	"01 < > 01",0
spread_mes		dc.b	" SPREAD  ",0
spread2_mes		dc.b	"01 --> 01",0
mode_mes		dc.b	"MODE: "
col_nbr_mes		dc.b	"01020304050607080910111213141516171819"
			dc.b	"20212223242526272829303132"
rgb_mes			dc.b	"RGB"
mode_onoff_mes		dc.b	"-*"
			even

* ------------------------------------------------------------- la copperlist *
copper			dc.w	$8e,$20e1,$90,$1bff
			dc.w	$92,$38,$94,$d8
text_bps		dc.w	$e0,0,$e2,0,$e4,0,$e6,0
			dc.w	$100,$a200
			dc.w	$102,0,$104,0
			dc.w	$108,0,$10a,0
sprites_bps		dc.w	$120,0,$122,0,$124,0,$126,0
			dc.w	$128,0,$12a,0,$12c,0,$12e,0
			dc.w	$130,0,$132,0,$134,0,$136,0
			dc.w	$138,0,$13a,0,$13c,0,$13e,0
			dc.w	$180,0,$182,$102
			dc.w	$184,$666,$186,$f66
			dc.w	$2109,-2,$180,$fff
			dc.w	$2209,-2,$180,$203
spr_palette1		dc.w	$2409,-2
sprite_cols		dc.w	$1a6,0,$1a4,0,$1ae,0,$1ac,0
			dc.w	$1b6,0,$1b4,0,$1be,0,$1bc,0
spr_palette2		dc.w	$3209,-2
			dc.w	$1a6,0,$1a4,0,$1ae,0,$1ac,0
			dc.w	$1b6,0,$1b4,0,$1be,0,$1bc,0
spr_palette3		dc.w	$4009,-2
			dc.w	$1a6,0,$1a4,0,$1ae,0,$1ac,0
			dc.w	$1b6,0,$1b4,0,$1be,0,$1bc,0
spr_palette4		dc.w	$4e09,-2
			dc.w	$1a6,0,$1a4,0,$1ae,0,$1ac,0
			dc.w	$1b6,0,$1b4,0,$1be,0,$1bc,0
			dc.w	$5d09,-2,$100,0
			dc.w	$6009,-2,$180,$fff
			dc.w	$100,0
			dc.w	$e0
lbw002742		dc.w	0,$e2,0
			dc.w	$e4,0,$e6,0,$e8,0,$ea,0
			dc.w	$ec,0,$ee,0,$f0,0,$f2,0,$f4,0,$f6,0
			dc.w	$8e,$2c81,$90,$2bc1
			dc.w	$108
lbw002772		dc.w	0,$10a
lbw002776		dc.w	0,$92
lbw00277a		dc.w	$38,$94
lbw00277e		dc.w	$d0,$104,0
			dc.w	$6109
lbw002786		dc.w	-2
palette			dc.w	$180,0,$182,0,$184,0,$186,0,$188,0
			dc.w	$18a,0,$18c,0,$18e,0,$190,0,$192,0
			dc.w	$194,0,$196,0,$198,0,$19a,0,$19c,0
			dc.w	$19e,0,$1a0,0,$1a2,0,$1a4,0,$1a6,0
			dc.w	$1a8,0,$1aa,0,$1ac,0,$1ae,0,$1b0,0
			dc.w	$1b2,0,$1b4,0,$1b6,0,$1b8,0,$1ba,0
			dc.w	$1bc,0,$1be,0
			dc.w	$6209,-2,$100
bp_pointeur		dc.w	$200
pal1			dc.w	-33,-2,$90,$2ac1
pal2			dc.w	$2b09,-2,$180,$fff,$100,0
pal3			dc.w	$2c09,-2,$180,$203
			dc.l	-2
fincopper		end
